Name:		libsmi	
Version:	0.5.0	
Release:	1%{?dist}
Summary:	Library which allows management applications to access SMI MIB module definitions

Group:		system/Libraries
License:	BSD and GPLv2+
URL:		https://www.ibr.cs.tu-bs.de/projects/libsmi/
Source:		https://www.ibr.cs.tu-bs.de/projects/libsmi/download/%{name}-%{version}.tar.gz

BuildRequires:	flex libtool pkgconfig bison

%description
On top of this library, there are tools to check, analyze dump, convert, and compare MIB definitions. Finally, the distribution contains a steadily maintained and revised archive of all IETF and IANA maintained standard MIB and PIB modules.
The library is internally divided into two layers. The upper layers represent the API to applications that make use of libsmi. Furthermore, the upper layer holds the MIB information in common internal data structures. The lower layer contains the drivers that implement the access to persistent MIB module repositories. Currently drivers for SMIv1/v2 MIB module files and for SPPI PIB module files exist. A driver for an early draft of SMIng is also present. 

%package devel
summary:  This will conatins header files for %{name} 
Requires: %{name} = %{version}

%description devel
This package contains the header files for %{name} package
%prep
%setup -q -n %{name}-%{version}

%build
./configure --prefix=/usr --libdir=%{_libdir}  --enable-shared --enable-static=no 

%install
make install DESTDIR=%{buildroot}
rm -rf %{buildroot}/usr/share/yang/
rm -f %{buildroot}%{_libdir}/*.la
%post 
/sbin/ldconfig

%postun 
/sbin/ldconfig

%files
%defattr(-, root, root)
%doc ANNOUNCE COPYING ChangeLog README THANKS TODO doc/*.txt
%doc %{_mandir}/man?/*
%{_bindir}/*
%{_datadir}/mibs
%{_datadir}/pibs
%{_libdir}/libsmi.so*

%files devel
%defattr(-, root, root)
%{_includedir}/*
%{_libdir}/pkgconfig/libsmi.pc
%{_datadir}/aclocal/libsmi.m4

%changelog

