%define _prefix /usr
%define wx_ver 3.0
%define buildname gtk2u

Name:		wxGtk
Version:	3.0.2
Release:	1%{?dist}
Summary:	The GTK port of the wxWindows library
Packager:	OpenClovis Inc <info@openclovis.com>
Group:		X11/Libraries
License:	wxWidgets Library Licence
URL:		http://www.wxwindows.org/
Source:		http://downloads.sourceforge.net/project/wxwindows/%{version}/wxWidgets-%{version}.tar.bz2
BuildRequires:  libpng-devel, GConf2-devel, gtk2-devel, gstreamer-devel, gstreamer-plugins-base-devel, expat-devel
BuildRequires:  zlib-devel, libjpeg-turbo-devel, libtiff-devel, cairo-devel, gcc-c++, mesa-libGL-devel, mesa-libGLU-devel
Requires:       wxBase
Provides: 	wxwin
Provides: 	wxGTK

%description
wxWindows is a free C++ library for cross-platform GUI development.
With wxWindows, you can create applications for different GUIs (GTK+,
Motif/LessTif, MS Windows, Mac) from the same source code.

%package -n wx-i18n
Summary: The translations for the wxWidgets library.
Group: X11/Libraries

%description -n wx-i18n
The translations files for the wxWidgets library.

%package devel
Summary: The gtk2  port of the wxWidgets library
Group: X11/Libraries
Requires: %{name} = %{version}
Requires: wxBase-devel = %{version}
Provides: wxGTK-devel

%description devel
The gtk2 port of the wxWidgets library, header files.

%package gl
Summary: The gtk2 port of the wxWidgets library, OpenGL add-on.
Group: X11/Libraries
Requires: %{name} = %{version}
Provides: wxGTK-gl

%description gl
OpenGL add-on library for wxGTK, the gtk2 port of the wxWidgets library.

%package -n wxBase
Summary: wxBase library - non-GUI support classes of the wxWidgets toolkit
Group: Development/Libraries

%description -n wxBase
wxBase is a collection of C++ classes providing basic data structures (strings,
lists, arrays), portable wrappers around many OS-specific funstions (file
operations, time/date manipulations, threads, processes, sockets, shared
library loading) as well as other utility classes (streams, archive and
compression). wxBase currently supports Win32, most Unix variants (Linux,
FreeBSD, Solaris, HP-UX) and MacOS X (Carbon and Mach-0).

%package -n wxBase-devel
Summary: wxBase library, header files.
Group: Development/Libraries

%description -n wxBase-devel
wxBase library - non-GUI support classes of the wxWidgets toolkit,
header files.

%prep
%setup -q -n wxWidgets-%{version}

%build
export MAKE="make"

mkdir wxgtk-build-dir
cd  wxgtk-build-dir
../configure  --prefix=%{_prefix} --libdir=%{_libdir} --with-gtk=2 --disable-optimise --enable-debug --enable-debug_info --enable-unicode \
              --enable-debug_gdb --enable-http --enable-aui --enable-html --with-zlib --with-libjpeg --with-libpng  --with-expat \
              --enable-gif --enable-image --enable-dragimage --enable-mousewheel --enable-tooltips --enable-menus --enable-gui --with-opengl \
              --enable-mediactrl  
$MAKE

cd ..

make -C locale allmo	

%install
rm -rf $RPM_BUILD_ROOT
(cd wxgtk-build-dir; make DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix} install)

# --- wxBase headers list begins here ---
cat <<EOF >wxbase-headers.files
wx/afterstd.h
wx/any.h
wx/anystr.h
wx/app.h
wx/apptrait.h
wx/archive.h
wx/arrimpl.cpp
wx/arrstr.h
wx/atomic.h
wx/base64.h
wx/beforestd.h
wx/buffer.h
wx/build.h
wx/chartype.h
wx/checkeddelete.h
wx/chkconf.h
wx/clntdata.h
wx/cmdargs.h
wx/cmdline.h
wx/confbase.h
wx/config.h
wx/convauto.h
wx/containr.h
wx/cpp.h
wx/crt.h
wx/datetime.h
wx/datstrm.h
wx/dde.h
wx/debug.h
wx/defs.h
wx/dir.h
wx/dlimpexp.h
wx/dlist.h
wx/dynarray.h
wx/dynlib.h
wx/dynload.h
wx/encconv.h
wx/event.h
wx/eventfilter.h
wx/evtloop.h
wx/except.h
wx/features.h
wx/flags.h
wx/ffile.h
wx/file.h
wx/fileconf.h
wx/filefn.h
wx/filename.h
wx/filesys.h
wx/fontenc.h
wx/fontmap.h
wx/fs_arc.h
wx/fs_filter.h
wx/fs_mem.h
wx/fs_zip.h
wx/hash.h
wx/hashmap.h
wx/hashset.h
wx/html/forcelnk.h
wx/iconloc.h
wx/init.h
wx/intl.h
wx/iosfwrap.h
wx/ioswrap.h
wx/ipc.h
wx/ipcbase.h
wx/kbdstate.h
wx/language.h
wx/link.h
wx/list.h
wx/listimpl.cpp
wx/log.h
wx/longlong.h
wx/math.h
wx/memconf.h
wx/memory.h
wx/memtext.h
wx/mimetype.h
wx/module.h
wx/mousestate.h
wx/msgout.h
wx/msgqueue.h
wx/mstream.h
wx/numformatter.h
wx/object.h
wx/platform.h
wx/platinfo.h
wx/power.h
wx/process.h
wx/ptr_scpd.h
wx/ptr_shrd.h
wx/recguard.h
wx/regex.h
wx/rtti.h
wx/scopedarray.h
wx/scopedptr.h
wx/scopeguard.h
wx/sharedptr.h
wx/snglinst.h
wx/sstream.h
wx/stack.h
wx/stackwalk.h
wx/stdpaths.h
wx/stdstream.h
wx/stockitem.h
wx/stopwatch.h
wx/strconv.h
wx/stream.h
wx/string.h
wx/stringimpl.h
wx/stringops.h
wx/strvararg.h
wx/sysopt.h
wx/tarstrm.h
wx/textbuf.h
wx/textfile.h
wx/thread.h
wx/thrimpl.cpp
wx/time.h
wx/timer.h
wx/tls.h
wx/tokenzr.h
wx/tracker.h
wx/translation.h
wx/txtstrm.h
wx/typeinfo.h
wx/types.h
wx/unichar.h
wx/uri.h
wx/ustring.h
wx/utils.h
wx/variant.h
wx/vector.h
wx/version.h
wx/versioninfo.h
wx/volume.h
wx/weakref.h
wx/wfstream.h
wx/wx.h
wx/wxchar.h
wx/wxcrt.h
wx/wxcrtbase.h
wx/wxcrtvararg.h
wx/wxprec.h
wx/xlocale.h
wx/xti.h
wx/xti2.h
wx/xtistrm.h
wx/xtictor.h
wx/xtihandler.h
wx/xtiprop.h
wx/xtitypes.h
wx/zipstrm.h
wx/zstream.h
wx/meta/convertible.h
wx/meta/if.h
wx/meta/implicitconversion.h
wx/meta/int2type.h
wx/meta/movable.h
wx/meta/pod.h
wx/fswatcher.h
wx/generic/fswatcher.h
wx/unix/app.h
wx/unix/apptbase.h
wx/unix/apptrait.h
wx/unix/chkconf.h
wx/unix/evtloop.h
wx/unix/evtloopsrc.h
wx/unix/pipe.h
wx/unix/stdpaths.h
wx/unix/stackwalk.h
wx/unix/tls.h
wx/unix/fswatcher_kqueue.h
wx/unix/execute.h
wx/unix/mimetype.h
wx/unix/fswatcher_inotify.h
wx/fs_inet.h
wx/protocol/file.h
wx/protocol/ftp.h
wx/protocol/http.h
wx/protocol/log.h
wx/protocol/protocol.h
wx/sckaddr.h
wx/sckipc.h
wx/sckstrm.h
wx/socket.h
wx/url.h
wx/xml/xml.h
wx/xtixml.h
EOF
# --- wxBase headers list ends here ---

# --- wxBase headers list with paths ---
sed -e 's@^@%{_includedir}/wx-%{wx_ver}/@' wxbase-headers.files > wxbase-headers.paths

# temporarily remove base headers
mkdir $RPM_BUILD_ROOT/_save_dir
cp -r $RPM_BUILD_ROOT%{_includedir}/wx-%{wx_ver} $RPM_BUILD_ROOT/_save_dir
for f in `cat wxbase-headers.files` ; do
    rm -f $RPM_BUILD_ROOT%{_includedir}/wx-%{wx_ver}/$f
done
# list of all core headers:
find $RPM_BUILD_ROOT%{_includedir}/wx-%{wx_ver} -type f | sed -e "s,$RPM_BUILD_ROOT,,g" >core-headers.files
# move base headers (actually all headers) back again
cp -f -r $RPM_BUILD_ROOT/_save_dir/* $RPM_BUILD_ROOT%{_includedir}
rm -rf $RPM_BUILD_ROOT/_save_dir

# utils:
(cd wxgtk-build-dir/utils/wxrc; make DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix} install)

# wx-config link is created during package installation, remove it for now
rm -f $RPM_BUILD_ROOT%{_bindir}/wx-config

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%post devel
ln -sf %{_libdir}/wx/config/gtk2-unicode-%{wx_ver} %{_bindir}/wx-config
/sbin/ldconfig

%postun devel
/sbin/ldconfig

%preun devel
rm -f %{_bindir}/wx-config

%post -n wxBase
/sbin/ldconfig

%postun -n wxBase
/sbin/ldconfig

%post -n wxBase-devel
/sbin/ldconfig

%postun  -n wxBase-devel
/sbin/ldconfig

%post gl
/sbin/ldconfig

%postun gl
/sbin/ldconfig

%files
%doc *.txt
%{_libdir}/libwx_%{buildname}_adv-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_aui-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_core-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_gl-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_html-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_media-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_propgrid-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_qa-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_ribbon-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_richtext-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_stc-%{wx_ver}.so*
%{_libdir}/libwx_%{buildname}_xrc-%{wx_ver}.so*
%files -n wx-i18n
%defattr(-,root,root)
%{_datadir}/locale/*/LC_MESSAGES/*.mo

%files devel -f core-headers.files
%defattr(-,root,root)
%dir %{_libdir}/wx
%{_libdir}/wx/config/gtk2-unicode-%{wx_ver}
%{_libdir}/wx/include/gtk2-unicode-%{wx_ver}/wx/setup.h
%{_bindir}/wxrc*

%files -n wxBase
%defattr(-,root,root)
%{_libdir}/libwx_base*-%{wx_ver}.so*

%files -n wxBase-devel -f wxbase-headers.paths
%defattr (-,root,root)
%dir %{_includedir}/wx-%{wx_ver}
%dir %{_libdir}/wx
%{_datadir}/aclocal/*.m4
%{_datadir}/bakefile/presets/*

%files gl
%defattr(-,root,root)
%{_libdir}/libwx_%{buildname}_gl-%{wx_ver}.so.*

%changelog
* Thu Feb 04 2016 OpenClovis Inc <info@openclovis.com> 
- Initial package version for wxWidgets3.0 on centos7. 
