#Below two macros are added to skip *.pyc and *.pyo files in the RPM package
%define _python_bytecompile_errors_terminate_build 0
%define py_site_arch %(%{__python} -c 'from distutils.sysconfig import get_python_lib; print get_python_lib(1)')
%define py_site_lib  %(%{__python} -c 'from distutils.sysconfig import get_python_lib; print get_python_lib()')


Name:		wxPython		
Version:	3.0.2.0
Release:	1%{?dist}
Summary:	Python bindings for wxWindows

Group:		Development/Tools
License:	GPL
URL:		http://www.wxpython.org/
Source:	        http://downloads.sourceforge.net/projects/wxpython/files/%{name}/%{version}/%{name}-src-%{version}.tar.bz2
BuildRequires:	python, gcc-c++, python-devel, wxGtk-devel >= 3.0.2,  wxGtk-gl >= 3.0.2, wxBase-devel >= 3.0.2
Requires:	python-devel, wxGtk-devel >= 3.0.2, wxGtk-gl >= 3.0.2, wxBase-devel >= 3.0.2 
Obsoletes: 	compat-wxPythonGTK < 2.8.4.0, wxPython <= 3.0.2

%description
wxPython is a GUI toolkit for the Python programming language. It allows
Python programmers to create programs with a robust, highly functional
graphical user interface, simply and easily. It is implemented as a Python
extension module (native code) that wraps the popular wxWidgets cross
platform GUI library, which is written in C++.

Like Python and wxWidgets, wxPython is Open Source which means that it is
free for anyone to use and the source code is available for anyone to look
at and modify. Or anyone can contribute fixes or enhancements to the
project.

wxPython is a cross-platform toolkit. This means that the same program will
run on multiple platforms without modification. Currently supported
platforms are 32-bit Microsoft Windows, most Unix or unix-like systems, and
Macintosh OS X.

%package devel
Summary: Development files for wxPython add-on modules
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: wxGTK-devel >= 3.0.2

%description devel
This package includes C++ header files and SWIG files needed for developing
add-on modules for wxPython. It is NOT needed for development of most
programs which use the wxPython toolkit.

%prep
%setup -q -n wxPython-src-%{version}/wxPython

%build
python setup.py build WXPORT="gtk2" UNICODE="1"

%install
rm -rf %{buildroot}
python setup.py install --root="%{buildroot}" WXPORT="gtk2" UNICODE="1"
%if "%{python_sitelib}" != "%{python_sitearch}"
%{__mv} %{buildroot}%{py_site_lib}/wx.pth  %{buildroot}%{py_site_arch}
%{__mv} %{buildroot}%{py_site_lib}/wxversion.py* %{buildroot}%{py_site_arch}
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc demo/ docs/ licence/ samples/
%{_bindir}/*
%{py_site_arch}/wx.pth
%{py_site_arch}/wxversion.py*
%dir %{py_site_arch}/wx-3.0-gtk2/
%{py_site_arch}/wx-3.0-gtk2/wx/
%{py_site_lib}/*.egg-info
%{py_site_arch}/wx-3.0-gtk2/*.egg-info

%files devel
%defattr(-, root, root, 0755)
%dir %{_includedir}/wx-3.0/
%dir %{_includedir}/wx-3.0/wx/
%dir %{_includedir}/wx-3.0/wx/wxPython/
%{_includedir}/wx-3.0/wx/wxPython/*.h
%dir %{_includedir}/wx-3.0/wx/wxPython/i_files/
%{_includedir}/wx-3.0/wx/wxPython/i_files/*.i
%{_includedir}/wx-3.0/wx/wxPython/i_files/*.py*
%{_includedir}/wx-3.0/wx/wxPython/i_files/*.swg

%changelog
* Thu Feb 04 2016 OpenClovis Inc <info@openclovis.com>
- Initial package version for wxPython3.0 gtk2 port on centos7.
