#Below two macros are added to skip *.pyo files in the RPM package
%define __python 0
%define _python_bytecompile_errors_terminate_build 0
my_build_arch:
%define saf_mgt_prefix %{prefix}/mgt
%define saf_cli_prefix %{prefix}/cli

Name:		safplus-mgt	
Version:	
Summary:	Management solution for monitor and control the manageable devices
Group:		Development/Libraries
License:        commercial license or GPL-3.0+
URL:            http://www.openclovis.com
Vendor:         OpenClovis Inc
Packager:       OpenClovisInc <info@openclovis.com>
BuildRequires: libssh2-devel zlib-devel perl libsmi-devel >= 0.5 net-snmp net-snmp-devel net-snmp-utils net-snmp-perl net-snmp-agent-libs
BuildRequires: python-ncclient ncurses-devel epel-release
Requires: epel-release boost-devel openssh  python-devel python-pip libssh2-devel zlib-devel perl libsmi >= 0.5 net-snmp net-snmp-devel 
Requires: net-snmp-utils net-snmp-perl net-snmp-agent-libs ncurses-devel python-ncclient
AutoReqProv: no
Prefix:
%description
SAFplus-mgt is a software which allows the user to access and manipulate the management information
of manageable devices flexibly via different kind of configuration interfaces. The SAFplus Management system provides
an integrated NETCONF, SNMP, CLI (local and remote), local API, and web access platform whose data model presents
on these northbound interfaces as a single management data configuration and statistics tree.
Yet data can be stored and requests serviced by many separate applications running on many nodes in a cluster.
Incoming requests from multiple protocol handlers are automatically translated into a standard high performance message
request format and routed to the application that is currently servicing that portion of the data tree.
Data routing is dynamic. Applications can "bind" to portions of the tree at any time, allowing data servicing to be handed
from one application to another and for crashing applications to be seamlessly restarted or failed over.

%package -n safplus-cli
Summary: CLI which is used to issue NETCONF access requests to the safplus-mgt
Group:   Development/Libraries
obsoletes: libsmi-devl <= %{name}
Requires: epel-release python python-pip python-devel libssh2-devel numpy python-matplotlib wxPython >= 3.0  librsvg2  
Requires: gnome-python2-rsvg

%description -n safplus-cli
safplus-cli can used in either "remote access"  or "local access" mode. In "local access" mode CLI accesses the management information via direct API calls. In "remote access" mode web browser or other web applications may be used to access data using the RESTCONF protocol 

%build
echo "Building is not required"

%install
rm -rf %{buildroot}
echo %{_builddir}
mkdir -p %{buildroot}%{saf_mgt_prefix}
rsync -avr --exclude 'mgtcli' %{_builddir}/ %{buildroot}%{saf_mgt_prefix}
mkdir -p %{buildroot}%{saf_cli_prefix}
cp -r %{_builddir}/mgtcli/* %{buildroot}%{saf_cli_prefix}

%clean
rm -rf %{buildroot}

%files
%{saf_mgt_prefix}/*

%files -n safplus-cli
%{saf_cli_prefix}/*

%pre -n safplus-cli
check_and_install_pypi_packages() {
  python -c "$1" >/dev/null 2>&1
  pkg_status=$?
  if [ "$pkg_status" -ne 0 ]; then
    printf "Installing $2 using pip\n"
    output="$(pip install $2)"
    if [ $? -ne 0 ]; then
      printf "$1 installation failed with below message $output\n"
      exit -1
    fi
  fi
}
check_and_install_pypi_packages "import pyang"  "pyang"
check_and_install_pypi_packages "import ncclient"  "ncclient"

%post -n safplus-cli
CLI_DIR=%{saf_cli_prefix}
SYM_LINK_DIR=/usr/local/bin
CLI_NAME=safplus_cli
if [ ! -f $SYM_LINK_DIR/$CLI_NAME ]
then
  /bin/ln -s $CLI_DIR/cli.py $SYM_LINK_DIR/$CLI_NAME
fi

%preun -n safplus-cli
CLI_DIR=%{saf_cli_prefix}
SYM_LINK_DIR=/usr/local/bin
CLI_NAME=safplus_cli
if [ "$1" == "0" ]
then
  printf "Preparing to uninstall the safplus-cli\n"
  if [ -f $SYM_LINK_DIR/$CLI_NAME ]
  then
    unlink $SYM_LINK_DIR/$CLI_NAME
  fi
  if [ -d $CLI_DIR ]; then
      cd $(dirname $CLI_DIR) && rm -rf $(basename $CLI_DIR)
  fi
else
  printf "preparing to update the safplus-cli\n"
fi

%pre 
check_and_install_pypi_packages() {
  python -c "$1" >/dev/null 2>&1
  pkg_status=$?
  if [ "$pkg_status" -ne 0 ]; then
    printf "Installing $2 using pip\n"
    output="$(pip install $2)"
    if [ $? -ne 0 ]; then
      printf "$1 installation failed with below message $output\n"
      exit -1
    fi
  fi
}
check_and_install_pypi_packages "import pyang"  "pyang"
check_and_install_pypi_packages "import ncclient"  "ncclient"

%post 
SAF_PLUGIN_DIR=%{prefix}/sdk/target/%{tmp_target_platform}/plugin
MGT_PLUGIN_DIR=%{saf_mgt_prefix}/plugin
if [ ! -d $SAF_PLUGIN_DIR ]
then
  mkdir -p $SAF_PLUGIN_DIR
fi
if [ ! -f $SAF_PLUGIN_DIR/libclSQLiteDB.so ] 
then
    /bin/cp -rf $MGT_PLUGIN_DIR/*  $SAF_PLUGIN_DIR/
fi
rm -rf $MGT_PLUGIN_DIR
/bin/ln -s $SAF_PLUGIN_DIR $MGT_PLUGIN_DIR

%preun
SAF_TOP_DIR=%{prefix}/sdk
SAF_MGT_PREFIX_DIR=%{saf_mgt_prefix}
if [ "$1" == "0" ]
then
  if [ -d $SAF_MGT_PREFIX_DIR ]
  then
    cd $(dirname $SAF_MGT_PREFIX_DIR) && rm -rf $(basename $SAF_MGT_PREFIX_DIR)
  fi
  rpm -q safplus >/dev/null 2>&1
  pkg_safplus_status=$?
  rpm -q safplus-src >/dev/null 2>&1
  pkg_safplus_src_status=$?
  if [ $pkg_safplus_status -ne 0 ] && [ $pkg_safplus_src_status -ne 0 ]
  then
    cd $(dirname $SAF_TOP_DIR) && rm -rf $(basename $SAF_TOP_DIR)
  fi
else
  printf "Preparing to uninstall the safplus-cli package..\n"
fi
    
%changelog
* Wed Feb 10 2016 OpenClovis Inc <info@openclovis.com>
- This release will contains the git-hub code changes upto commit 68d68e8 Added changes to the change log for new package generation
