S7 := 1
ifeq ($(SAFPLUS_SRC_DIR),)
$(error You must run this as a submake or define the SAFPLUS_SRC_DIR environment variable)
endif

include $(SAFPLUS_SRC_DIR)/mk/preface.mk

# Specify the required libraries
SAFPLUS_LIBS := clMgt

# Then use these in the make rule
SAFPLUS_DEP_LIBS     := $(addsuffix .so,$(addprefix $(LIB_DIR)/lib,$(SAFPLUS_LIBS)))
SAFPLUS_LINK_LIBS := -L$(LIB_DIR) $(addprefix -l,$(SAFPLUS_LIBS))

${YANG_MODULE}_SRC := $(wildcard *.cxx)
${YANG_MODULE}_H := $(wildcard *.hxx)

${YANG_MODULE}_OBJ := $(subst .cxx,.o,$(notdir $(${YANG_MODULE}_SRC)))
${YANG_MODULE}_OBJ := $(addprefix $(OBJ_DIR)/${YANG_MODULE}/,$(${YANG_MODULE}_OBJ))

${YANG_MODULE}_LIB := lib${YANG_MODULE}.so

# Management includes and libraries
CPP_FLAGS += $(SAFPLUS_MGT_INC_FLAGS)

Release all: $(LIB_DIR)/$(${YANG_MODULE}_LIB)

# Shared library providing functions that needs to provide that YANG data
$(LIB_DIR)/$(${YANG_MODULE}_LIB): $(${YANG_MODULE}_OBJ) $(SAFPLUS_DEP_LIBS)
	$(LINK_SO) $@ $(${YANG_MODULE}_OBJ) $(SAFPLUS_LINK_LIBS) -L$(INSTALL_DIR)/lib -lxml2 $(LINK_SO_LIBS)

$(OBJ_DIR)/${YANG_MODULE}/%.o: %.cxx $(${YANG_MODULE}_H)
	-mkdir -p $(OBJ_DIR)/${YANG_MODULE}
	$(COMPILE_CPP) $@ $(SAFPLUS_MGT_INC_FLAGS) $<

clean:
	rm -rf $(OBJ_DIR)/${YANG_MODULE} $(LIB_DIR)/$(${YANG_MODULE}_LIB)

include $(SAFPLUS_MAKE_DIR)/safplus_targets.mk
