S7 := 1
ifeq ($(MGT_SRC_DIR),)
$(error Cannot find MGT_SRC_DIR. Please export it)
endif
#mkfile_path := $(abspath $(lastword $(MAKEFILE_LIST)))
#BUILD_DIR ?= $(patsubst %/,%, $(dir $(mkfile_path)))
#BUILD_DIR ?= $(shell (cd $(SAFPLUS_DIR)/target/

#ifneq ($(wildcard ../../../mgtpreface.mk),) 
include $(MGT_SRC_DIR)/../mgtpreface.mk
APP_TARGET := $(SAFPLUS_TARGET)
BUILD_DIR ?= $(APP_TARGET)
#else
#APP_TARGET := $(SAFPLUS_TARGET)
$(info $(APP_TARGET))
NOOP := $(shell mkdir -p $(BUILD_DIR)/target)
NOOP := $(shell mkdir -p $(BUILD_DIR)/target/obj)
#LIB_DIR := /opt/safplus/7.0/sdk/target/lib
#include /opt/safplus/7.0/mgt/mgtpreface.mk
#endif

APP_LIB_DIR ?= $(APP_TARGET)
APP_BIN_DIR ?= $(APP_TARGET)
APP_OBJ_DIR ?= $(APP_TARGET)/obj

CLIENT_H := $(wildcard *.hpp) $(wildcard $(SAFPLUS_INC_DIR)/*.hpp) 
CLIENT_SRC := $(wildcard *.cxx)
CLIENT_OBJ := $(addprefix $(APP_OBJ_DIR)/,$(subst .cxx,.o,$(CLIENT_SRC)))

MODELS := $(wildcard *.xml)
MODELS_TGT := $(addprefix $(APP_BIN_DIR)/,$(MODELS))

# Specify the required libraries
SAFPLUS_LIBS := clAmf clMgt clRpc clName clCkpt clGroup clTimer clMsg clLog clUtils clOsal clFault clDbal
# Then use these in the make rule
SAFPLUS_DEP_LIBS     := $(addsuffix .so,$(addprefix $(LIB_DIR)/lib,$(SAFPLUS_LIBS)))
SAFPLUS_LINK_LIBS := -L$(LIB_DIR) $(addprefix -l,$(SAFPLUS_LIBS))

Release all: $(APP_BIN_DIR)/${YANG_MODULE} $(MODELS_TGT) $(APP_TARGET)/share/modules/openclovis/${YANG_MODULE}.yang #$(APP_TARGET)/share/modules/openclovis/${UC_YANG_MODULE}-MIB.txt #scripts

$(APP_BIN_DIR)/%.xml: %.xml
	cp -f $< $@

$(APP_BIN_DIR)/%.conf: %.conf
	cp -f $< $@

$(APP_BIN_DIR)/${YANG_MODULE}: $(CLIENT_OBJ) $(APP_LIB_DIR)/lib${YANG_MODULE}.so $(SAFPLUS_DEP_LIBS)
	$(LINK_EXE) $@ $(CLIENT_OBJ) -L$(APP_LIB_DIR) -l${YANG_MODULE} $(SAFPLUS_LINK_LIBS) -lboost_filesystem $(LINK_SO_LIBS) -lprotobuf -lprotoc $(LINK_SO_LIBS)

$(APP_OBJ_DIR)/%.o: %.cxx Makefile $(SAFPLUS_MAKE_DIR)/preface.mk $(CLIENT_H)
	$(COMPILE_CPP)  $@ $(SAFPLUS_MGT_INC_FLAGS) $< 

$(APP_LIB_DIR)/lib${YANG_MODULE}.so:
	$(MAKE) SAFPLUS_MGT_DIR=$(SAFPLUS_MGT_DIR) APP_TARGET=$(APP_TARGET) -C ${YANG_MODULE}

#yang:
#	PYTHONPATH=$(MGT_SRC_DIR)/3rdparty/pyang PYANG_PLUGINPATH=$(MGT_SRC_DIR)/pyplugin $(MGT_SRC_DIR)/3rdparty/pyang/bin/pyang --path=$(SAFPLUS_SRC_DIR)/yang -f y2cpp ${YANG_MODULE}.yang --y2cpp-output `pwd` --y2cpp-sdkdir $(SAFPLUS_SRC_DIR) --main

#yang2mib:
#	PYTHONPATH=$(MGT_SRC_DIR)/3rdparty/pyang PYANG_PLUGINPATH=$(MGT_SRC_DIR)/pyplugin $(MGT_SRC_DIR)/3rdparty/pyang/bin/pyang --path=$(SAFPLUS_SRC_DIR)/yang -f yang2smi myService.yang --yang2smi-oid=99840 -o MYSERVICE-MIB.txt

$(APP_TARGET)/share/modules/openclovis/${YANG_MODULE}.yang: ${YANG_MODULE}.yang
	@mkdir -p $(APP_TARGET)/share/modules/openclovis
	cp -rf $< $@

#$(APP_TARGET)/share/modules/openclovis/${UC_YANG_MODULE}-MIB.txt:
#	@mkdir -p $(APP_TARGET)/share/modules/openclovis
#	cp -rf $< $@

#scripts:
#	cp -f setup $(APP_TARGET)

clean:
	rm -f $(CLIENT_OBJ) $(APP_BIN_DIR)/${YANG_MODULE} $(OBJ_DIR)/${YANG_MODULE}/*
	$(MAKE) SAFPLUS_SRC_DIR=$(SAFPLUS_SRC_DIR) -C ${YANG_MODULE} clean

# include $(SAFPLUS_MAKE_DIR)/safplus_targets.mk
