if (Meteor.isServer) {

var base = process.env.PWD;

var exec = Npm.require('child_process').exec;
var Fiber = Npm.require('fibers');
var Future = Npm.require('fibers/future');

/* Router map http GET example */
// Add a mapping for route on the server. With the following route, all http requests 
// like this: http://<server>/xget?resourceURI=<uri> will be handled here
Router.map(function () {
  this.route('xget', {
  where: 'server',
  action: function () {
      console.log("Route map function param: method " + this.request.method);
      console.log("Route map function param: " + this.request.query.resourceURI);
      console.log("Route map function: calling python code"); 
      var ret = Meteor.call("callPython", this.request.query.resourceURI);
      this.response.writeHead(200, {'Content-Type': 'text/html'});
      this.response.end(ret +"\n");       
  }
 });
});
// This method calls a python program located on the server. This program uses ncclient library to
// talk to the netconf server
Meteor.methods({
  callPython: function(uri) {
    var fut = new Future();
    exec(base + '/public/script/pyRetrieve.py '+uri, function (error, stdout, stderr) {                
      console.log("Inside callback python func");
      console.log("error: " + error);
      console.log("RECEIVE stdout: " + stdout);
      console.log("stderr :" + stderr);            
      fut.return(stdout);
    });
    return fut.wait();
  },
});
}
