import sys,os,re
import logging
import pdb
from string import lower
import traceback
logging.basicConfig(filename='netconfaccess.log',level=logging.DEBUG)
#logging.basicConfig(level=logging.DEBUG)
import lxml.etree as et
import pyang
import mgtcommon
import ncclient
from ncclient import manager
from notification import Notification
from ncclient.operations import RPC
from ncclient.operations.rpc import RPCReply
print ncclient.__file__
from ncclient.operations.rpc import RPCError
from lxml import etree
import mgtserver,mgtobject,mgtcrypto
from ncclient.devices.default import DefaultDeviceHandler
from ncclient.xml_ import new_ele, sub_ele


try:
  import xmlterm
  windowed=True
except Exception, e:
  import textxmlterm as xmlterm
  windowed=False

NetconfSetPrefix = """<config xmlns:xc="urn:ietf:params:xml:ns:netconf:base:1.0">"""

NetconfSetSuffix = """</config>"""

mgtRootObject = None
modules = None

NetworkElementConnectedColor = (0,0x80,0)
NetworkElementDisconnectedColor = (0x80,0x80,0)

class Commands:
  def __init__(self):
    self.commands = { "add": { "element": (self.do_connect,self.complete_connect), "module": (self.add_module_cmd,None) },
                      "save": { None: (self.save_cmd,self.complete_save), "element": (self.save_element, self.complete_save_element) },

                      # Standard NETCONF Commands
                      "cancel-commit": (self.cancel_commit, None), # Cancel the current confirmed commit procedure
                      "close-session": (self.close_session, None), # Close the current NETCONF session
                      "commit": (self.commit, None),               # Make the candidate database be the running config
                      "copy-config": (self.copy_config, self.complete_copy_config), # Copy an entire NETCONF database
                      "create-subscription": (self.create_subscription, None),      # Start receiving NETCONF notifications
                      "delete-config": (self.delete_config, None),        # Delete an entire NETCONF database
                      "discard-changes": (self.discard_changes, None),              # Discard any edits in the candidate database
                      "edit-config": (self.edit_config, None),     # Alteration of the target database
#                      "get" : (self.get, None),                    # Filtered retrieval of state data and running config
                      "get-config" : (self.get_config, None),      # Filtered retrieval of any NETCONF database
                      "get-schema" : (self.get_schema, None),      # Get a data model definition file from the server
                      "kill-session" : (self.kill_session, None),  # Force close another NETCONF session
                      "lock" : (self.lock, None),                  # Lock a NETCONF database that is currently unlocked
                      "unlock" : (self.unlock, None),              # Unlock a NETCONF database that is currently locked
                      "validate": (self.validate, None)#,           # Validate the contents of a NETCONF database
#                      "rpc": (self.do_rpc, None)          # send rpc to netconf server
    } 
    self.context = None
    self.database = "candidate" # default database

  def setContext(self,context):
    """Sets the context (environment) object so commands can access it while they are executing"""
    self.context = context

  def resolveNetworkElement(self):
    print "resolveNetworkElement"
    name = None
    elem = None
    if self.context.curdir != '':
      name = self.context.curdir.split("/")[1:2][0]

    if name and name is not '':
      elemlst = mgtRootObject.findByAttr({"listkey":name})
      elem = elemlst[0][1]
    print "resolveNetworkElement : %s " %name
    print "resolveNetworkElement : %s " %elem
    return  elem

  def complete_save_element(self):
    pass

  def complete_save(self, fname):
    pass

  def complete_copy_config(self):
    pass

  # Cancel the current confirmed commit procedure
  def cancel_commit(self):
    """? Cancel the current confirmed commit procedure"""
    pass

  # Close the current NETCONF session
  def close_session(self):
    """? The close-session command is used to terminate the current NETCONF session. 
    A NETCONF server should always accept this command if it is valid, and not reject it due to 
    access control enforcement or if the server is in notification delivery mode.
    """
    pass

  # Make the candidate database be the running config
  def do_commit(self):
    """? The commit command is used to save the edits in the candidate database into the running database
  Arguments: None
    """
    elem = self.resolveNetworkElement()
    if elem:
      try:
        return elem.cmd_commit()
      except RPCError, e:
        return etree.tostring(e.xml)
    return ""

  def commit(self):
    """? The commit command is used to save the edits in the candidate database into the running database
  Arguments: None
    """
    elem = self.resolveNetworkElement()
    if elem:
      try:
        return elem.cmd_commit()
      except RPCError, e:
        return etree.tostring(e.xml)
    return ""

  def delete_config(self):
    """? The delete-config command is used to delete an entire NETCONF database.
    Arguments: specifies the name of the target database for the delete operation.
    Example:
      delete-config candidate
    """
    pass

  # Copy an entire NETCONF database
  def copy_config(self, *args):
    elem = self.resolveNetworkElement()
    if elem:
      try:
        return elem.cmd_copy_config()
      except RPCError, e:
        return etree.tostring(e.xml)
    return ""

  # Start receiving NETCONF notifications
  def create_subscription(self):
    pass

  # Discard any edits in the candidate database
  def discard_changes(self):
    pass

  # Alteration of the target database
  def edit_config(self):
    pass

  # Filtered retrieval of state data and running config
#  def get(self):
#    pass

  # Filtered retrieval of any NETCONF database
  def get_config(self, xpath):
    elem = self.resolveNetworkElement()
    if elem:
      try:
        return elem.cmd_get_config(xpath)
      except RPCError, e:
        return etree.tostring(e.xml)
    return ""

  # Get a data model definition file from the server
  def get_schema(self):
    pass

  # Force close another NETCONF session
  def kill_session(self):
    pass

  # Lock a NETCONF database that is currently unlocked
  def lock(self):
    pass
  
  # Unlock a NETCONF database that is currently locked
  def unlock(self):
    pass

  # Validate the contents of a NETCONF database
  def validate(self):
    pass

  # Test:  cd /local/safplusAmf/Node; create /tmp; copy sc0 /tmp; create /diff; 
  #        [ WAIT! ]
  #        diff sc0 /tmp/Node/sc0 > /diff
  #        cd /diff/Node/stats/load/contextSwitches/current
  #        resolve b .

  def resolveNode(self,choice,node):
    ret = []
    count = 0
    if node.attributes_.has_key("conflict"):
      c = node.get(choice,None)
      if not c:
        ret.append("<warning>Unable to find choice [%s] at location [%s]</warning>" % (choice,node.fullPath()))
      else:
        count+=1
        c.tag_ = node.tag_
        node.steal(c)
        del c

    for c in node.children():
        if isinstance(c,mgtobject.MgtObject):
          cnt, e = self.resolveNode(choice,c)
          count += cnt
          ret += e
    return count,ret
    

  def do_resolve(self, choice, *pathList):
    """? Recursively resolve a conflict by picking one of the options.
  Arguments: choice pathList
  Example: Choose option "a" in the current location
     resolve a .
"""
    paths,errors = self.resolveStringPathList(pathList)
    
    for p in paths:
      count,e = self.resolveNode(choice,p)
      errors += e
      if count==0:
        errors.append("<warning>Location [%s] has no conflict</warning>" % p.fullPath())
    return "".join(errors)

  def do_freeze(self, *pathList):
    """? Stop updating all of these network elements.  No arguments freezes every network element"""
    return self.freeze(True,pathList)

  def do_thaw(self, *pathList):
    """? Resume updating all of these network elements.  No arguments thaws every network element"""
    return self.freeze(False,pathList)

  def freeze(self,state,pathList):
    ret = []
    paths = []
    elements = []

    if pathList:
      for p in pathList:
        if p[0] != "/": p = os.path.join(self.context.curdir, p)
        paths.append(p)

      for p in paths:
        t = p.split("/")
        destElem = mgtRootObject.resolvePath(t)
        if not destElem:
          ret.append("<warning>Path [%s] is invalid</warning>" % "/".join(t))
        elements += destElem
    else:
      elements = mgtRootObject.children(lambda x: isinstance(x,mgtserver.MgtServerObject))
      
    for d in elements:
      if isinstance(d,mgtserver.MgtServerObject):
        d.frozen = state
        ret.append(d.fullPath() + " ")
    return "".join(ret)
    
  def do_load(self,filename,location):
    """? Load an XML file into the configuration tree"""
    # TODO load into an existing tree (needs merge function)
  
    elem = mgtobject.loadFile(filename)
    
    # TODO rename the top level elem if location has an extra name specified
    pos = mgtRootObject.resolvePath(location)
    t = len(pos)
    if t==0:
      return "<error>Output location does not exist</error>"
    if t>1:
      return "<error>Path resolved to multiple locations</error>"
    if elem.tag_ == "top":  # We always skip "top".  Its just there to allow multiple <> at the top level
      for e in elem.child_.values():
        pos[0].addChild(e)
    else:
      pos[0].addChild(elem)    
    return ""

  def do_getconfig(self,*sp):
    """Displays the object tree at the current or specified location.
Arguments: [-N] location
By default the specified location and children are shown.  Use -N to specify how many children to show.  For example -2 will show this location, children and grandchildren.
    """
    #depth=1
    rest = ""
    if len(sp):
      if sp[0][0] == "-":  # Its a flag
        depth = int(sp[0][1:])  # depth modifier flag
        if len(sp)>2:
          rest = sp[1]
      else:
        rest = sp[0]
    t = os.path.normpath(os.path.join(self.context.curdir,rest))
    name = None
    gs = None
    if self.context.curdir != '':
      name = self.context.curdir.split("/")[1:2][0]
    if name:
      idx = t.find('/%s'%name,0)
      if idx==0:
        idx = t.find('/',1)
        if idx!=-1:
          gs = t[idx+1:]
    if not gs:
      gs = "%s" % str(t)
    #print "getting ", gs
    try:
      xml = mgtRootObject.getConfigValue(gs,self.database)
      #print xml
    except RuntimeError, e:
      if str(e) == "Route has no implementer":
        return "<error>Invalid path [%s]</error>" % str(t)
      return "<error>" + str(e) + "</error>"
    except Exception, e:
      return "<error>" + str(e) + "</error>"
    #print xml
    return "<top>" + xml + "</top>"

  def do_setdatabase(self,*locationsAndValue):
    #print locationsAndValue
    if len(locationsAndValue) < 1:
      raise xmlterm.CommandBadArgException("Not enough arguments")

    val = locationsAndValue[-1]  # grab the value
    self.database = val
    return ""

  def do_getdatabase(self):
    return "<database>%s</database>"%self.database

  def do_set(self, *locationsAndValue):
    """?  syntax: 
        set (one or more locations) (value)  
        set (one or more locations) = (value)

        Sets the leaf at the specified locations to the specified value
    """
    if len(locationsAndValue) < 2:
      raise xmlterm.CommandBadArgException("Not enough arguments")

    val = locationsAndValue[-1]  # grab the value
    cnt = -1
    if locationsAndValue[cnt] == "=":
      cnt -= 1
    locations = locationsAndValue[0:cnt]
    paths,errors = self.resolveStringPathList(locations)
#    pdb.set_trace()
    # TODO: combine all of these into one NETCONF set
    for p in paths:
      if p.isleaf:
        p.setValue(val,'running')
      else:
        errors.append("<warning>Location [%s] is not a leaf (it has no value to set)</warning>" % p.fullPath())
    return "".join(errors)

  def do_get(self, *locationsAndValue):
    """?  syntax: 
        set (one or more locations) 
        Sets the leaf at the specified locations to the specified value
    """
    if len(locationsAndValue) < 1:
      raise xmlterm.CommandBadArgException("Not enough arguments")
    print locationsAndValue
    paths,errors = self.resolveStringPathList(locationsAndValue)
    # TODO: combine all of these into one NETCONF set
    for p in paths:
      print p
      if p.isleaf:
        result=p.getValue()
        print result
      else:
        errors.append("<warning>Location [%s] is not a leaf (it has no value to set)</warning>" % p.fullPath())
    return "".join(errors)




  def xxxdo_set(self, *locationsAndValue):
    """?  syntax: 
        set (one or more locations) (value)  
        set (one or more locations) = (value)

        Sets the leaf at the specified locations to the specified value
    """
    if len(locationsAndValue) < 2:
      raise xmlterm.CommandBadArgException("Not enough arguments")
    val = locationsAndValue[-1]  # grab the value
    cnt = -1
    if locationsAndValue[cnt] == "=":
      cnt -= 1
    locations = locationsAndValue[0:cnt]
    paths,errors = self.resolveStringPathList(locations)
    elems = {}
    for p in paths:
      if p.isleaf:
        (elem,xml,localfn) = p.deferredSet(val)
        if not elems.has_key(elem): elems[elem] = []
        elems[elem].append((xml,localfn))
      else:
        errors.append("<warning>Location [%s] is not a leaf (it has no value to set)</warning>" % p.fullPath())
    for (e,ops) in elems.items():
      xml = [NetconfSetPrefix]
      for op in ops:
        xml.append(op[0])
      xml.append(NetconfSetSuffix)      
      netconfCmd = "\n".join(xml)
      print netconfCmd
      try:
        e.manager.edit_config(target="candidate", config=netconfCmd)
      except ncclient.operations.rpc.RPCError, e:
        
        print "Error %s" % str(e)
        print netconfCmd
        errors.append("<error>%s</error>" % str(e))
      except Exception, e:
        print e
        raise e  # SetOperationFailed("many elements","many values")           
      else:
        for op in ops:
          op[1]()
 
    return "".join(errors)
  

  def do_create(self,*pathList):
    ret = self.doOperation("create",*pathList)
    return ret

  def do_replace(self,*pathList):
    ret = self.doOperation("replace",*pathList)
    return ret

  def do_merge(self,*pathList):
    ret = self.doOperation("merge",*pathList)
    return ret

  def do_delete(self,*pathList):
    ret = self.doOperation("delete",*pathList)
    return ret

  def doOperation(self,operation,*pathList):
    """? Create XML nodes at the specified locations
    create existing path/new node
    Example:
      create /a/b/c
      creates the node c under the existing path /a/b
"""
    ret = []
    paths = []
    for p in pathList:
      if p[0] != "/": p = os.path.join(self.context.curdir, p)
      paths.append(p)

    for p in paths:
      # TODO allow multiple nodes to be created if the path /a/foo/bar is specified and only a exists.  To do this we need to extend resolvePaths to handle partial path resolutions
      t = p.split("/")
      name = t[-1]
      destElem = mgtRootObject.resolvePath(t[0:-1])
       
      if not destElem:
        try:
            # TODO: list element???
            key = modules.mapKeyList[t[-2]][0] 
            newname = t[-2] + "[" + key + "=" + name  + "]"
            mgtRootObject.valueOperation(newname,operation,self.database)
        except:
            ret.append("<warning>Path [%s] is invalid</warning>" % "/".join(t))
            traceback.print_exc()
      else:

        targets = []

        while destElem:  # This whole while loop handles transforming list/name syntax into the netconf list[key=name] syntax
          elem = destElem.pop()
          if elem.isListElem() and t[-2] == elem.tag_:  # if the structure is .../Node/newNodeName, we actually want to create a new list element, not a child of this element
            # TODO: This logic to determine what key to use is buggy.  Instead we should figure out which key is the "primary" and use it.
            # However for SAFplus yang models, the primary key is always "name" or there is just one key.  So this works.
            key = "name" if elem.keys.has_key("name") else elem.keys.keys()[0]
            newname = elem.tag_ + "[" + key + "=" + name  + "]"

            # resolvePath is going to give me every element of the yang list.  This is a small problem, I erase every element whose tag == mine and parent == my parent (i.e. every element of the list), so a multi-create will work.  
            destElem = filter(lambda x: not (x.tag_ == elem.tag_ and x.parent == elem.parent), destElem)
            targets.append((elem.parent, newname))
          else:
            """ TODO: build element for list if not existing """
            try:
                # TODO: list element???
                key = modules.mapKeyList[t[-2]][0] 
                newname = t[-2] + "[" + key + "=" + name  + "]"
                targets.append((mgtRootObject, newname))
            except:
                #traceback.print_exc()
                targets.append((elem,name))

        for (d,nodeName) in targets:
          ne = d.getNetworkElement()
          if ne:  # need to create a node on a device
            d.valueOperation(nodeName,operation,self.database)
          else:  # creating a local node
            d.addChild(mgtobject.MgtObject(d,{'tag_':nodeName},[],None))
    return "".join(ret)

  # Delete an entire NETCONF database
  def xxxdo_delete(self, *pathList):
    """? delete the XML nodes at the specified locations"""
    ret = []
    paths = []
    for p in pathList:
      if p[0] != "/": p = os.path.join(self.context.curdir, p)
      paths.append(p)

    for p in paths:
      t = p.split("/")
      name = t[-1]
      destElem = mgtRootObject.resolvePath(t)
      if not destElem:
        ret.append("<warning>Path [%s] is invalid</warning>" % "/".join(t))
      else:
        targets = []
        for elem in destElem:
          if elem.isListElem() and t[-2] == elem.tag_:  # if the structure is .../Node/newNodeName, we actually want to create a new list element, not a child of this element
            # TODO: This logic to determine what key to use is buggy.  Instead we should figure out which key is the "primary" and use it.
            # However for SAFplus yang models, the primary key is always "name" or there is just one key.  So this works.
            key = "name" if elem.keys.has_key("name") else elem.keys.keys()[0]
            newname = elem.tag_ + "[" + key + "=" + name  + "]"

            # resolvePath is going to give me every element of the yang list.  This is a small problem, I erase every element whose tag == mine and parent == my parent (i.e. every element of the list), so a multi-create will work.  
            destElem = filter(lambda x: not (x.tag_ == elem.tag_ and x.parent == elem.parent), destElem)
            targets.append((elem.parent, newname))
          else:
            targets.append((elem,name))

        for (d,nodeName) in targets:
          ne = d.getNetworkElement()
          if ne:
            ne.deleteValue(nodeName)
            #parent.delChild(d)
            #del d
          else:
            ret.append("<warning>Cannot delete root XML node</warning>")

    return "".join(ret)

  def do_delete(self, *pathList):
    """? Create XML nodes at the specified locations
    create existing path/new node
    Example:
      create /a/b/c
      creates the node c under the existing path /a/b
"""
    ret = []
    paths = []
    for p in pathList:
      if p[0] != "/": p = os.path.join(self.context.curdir, p)
      paths.append(p)

    for p in paths:
      # TODO allow multiple nodes to be created if the path /a/foo/bar is specified and only a exists.  To do this we need to extend resolvePaths to handle partial path resolutions
      t = p.split("/")
      name = t[-1]
      destElem = mgtRootObject.resolvePath(t[0:-1])

      if not destElem:
        try:
            # TODO: list element???
            key = modules.mapKeyList[t[-2]][0]
            newname = t[-2] + "[" + key + "=" + name  + "]"
            mgtRootObject.deleteValue(newname,self.database)
        except:
            ret.append("<warning>Path [%s] is invalid</warning>" % "/".join(t))
            traceback.print_exc()
      else:

        targets = []

        while destElem:  # This whole while loop handles transforming list/name syntax into the netconf list[key=name] syntax
          elem = destElem.pop()
          if elem.isListElem() and t[-2] == elem.tag_:  # if the structure is .../Node/newNodeName, we actually want to create a new list element, not a child of this element
            # TODO: This logic to determine what key to use is buggy.  Instead we should figure out which key is the "primary" and use it.
            # However for SAFplus yang models, the primary key is always "name" or there is just one key.  So this works.
            key = "name" if elem.keys.has_key("name") else elem.keys.keys()[0]
            newname = elem.tag_ + "[" + key + "=" + name  + "]"

            # resolvePath is going to give me every element of the yang list.  This is a small problem, I erase every element whose tag == mine and parent == my parent (i.e. every element of the list), so a multi-create will work.
            destElem = filter(lambda x: not (x.tag_ == elem.tag_ and x.parent == elem.parent), destElem)
            targets.append((elem.parent, newname))
          else:
            """ TODO: build element for list if not existing """
            try:
                # TODO: list element???
                key = modules.mapKeyList[t[-2]][0]
                newname = t[-2] + "[" + key + "=" + name  + "]"
                targets.append((mgtRootObject, newname))
            except:
                #traceback.print_exc()
                targets.append((elem,name))

        for (d,nodeName) in targets:
          ne = d.getNetworkElement()
          if ne:  # need to create a node on a device
            d.deleteValue(nodeName,self.database)
          else:  # creating a local node
            d.addChild(mgtobject.MgtObject(d,{'tag_':nodeName},[],None))
    return "".join(ret)


  def parseCmdLineArgs(self, cmd, ns, args):
    xml=""
    openTag = "<%s xmlns=\"%s\">" % (cmd, ns)
    closeTag = "</%s>" %(cmd)
    xml += openTag
    for arg in args:
      pattern = re.compile(r'''((?:[^="']|'[^']*')+)''')
      nv = pattern.split(arg)[1::2]
      nv = [v.replace("'","") for v in nv]
      tagName = nv[0]
      spaceIdx = tagName.find(' ')
      if spaceIdx>=0:
        tagName = tagName[:spaceIdx]
      if len(nv)==2:
        xml+="<%s>%s</%s>"%(nv[0],nv[1],tagName)
      else:
        xml+="<%s/>"%nv[0]
    xml+=closeTag
    return xml

  def do_rpc(self, *sp):
    logging.debug("DO RPC : [%s]" % sp[0])
    if (len(sp) <= 0):
      logging.debug("command invalid")
      return ""
    cmd = sp[0]
    ns = "http://www.myCompany.com/ns/myService"
    xml=""
    openTag = "<%s xmlns=\"%s\">" % (cmd, ns)
    closeTag = "</%s>" %(cmd)
    xml += openTag
    xml+="%s"%sp[1]
    xml+=closeTag
    print xml
    try:
      manager = mgtRootObject.getNetworkElement()
      rpc = RPC(manager.manager._session, device_handler=DefaultDeviceHandler(), async=manager.manager._async_mode, timeout=manager.manager._timeout, raise_mode=manager.manager._raise_mode)
      connected = True
      ret = rpc._request(etree.fromstring(xml))
      print ret
    except Exception, e:
        print "Error message: %s" % str(e)
  
  def handleRpc(self, *sp):
    """? Send an rpc command to Netconf server
    Syntax: rpc [NcxIdentifier] argument
    Example: rpc create-subscription stream=NETCONF
"""
    logging.debug("DO RPC : [%s]" % sp[0])
    if (len(sp) <= 0 or len(modules.mapKeyRpc) <= 0):
      return ""
    cmd = sp[0]
    if cmd=="connect":
      if len(sp)==6: # including port
        self.do_connect(sp[1],sp[2],sp[3],sp[4],sp[5])
      elif len(sp)==5:
        self.do_connect(sp[1],sp[2],sp[3],sp[4])
      else:
        print 'invalid parameters'
      return
    if cmd=="rpc":
      self.do_connect(sp[1])
      return
    rpcStatement = None
    for key in modules.mapKeyRpc:
    #Check if the rpc command is loaded
      if(cmd == key):
        rpcStatement = modules.mapKeyRpc[cmd]
        break
    if not rpcStatement:
      return "<error>Rpc command [%s] is not loaded</error>" % sp[0]
    else:
      ns = rpcStatement.top.search_one('namespace').arg
      locationsAndValue = sp[ 1 : ]
      xml = self.parseCmdLineArgs(cmd, ns, locationsAndValue)
      if xml=="":
        return ""

      connected = False
      try:
        manager = mgtRootObject.getNetworkElement()
        rpc = RPC(manager.manager._session, device_handler=DefaultDeviceHandler(), async=manager.manager._async_mode, timeout=manager.manager._timeout, raise_mode=manager.manager._raise_mode)
        connected = True
        ret = rpc._request(etree.fromstring(xml))
        print ret
      except Exception, e:
        print "Error message: %s" % str(e)
        if not connected:
          print 'Did you forget to connect to netconf server?'
    return ""
  
  def do_notification(self, *sp):
    """? Setting and show received notifications
    Syntax: notification [NcxIdentifier] (on/off)
        If [NcxIdentifier] is "all" turn all notifications on or off
        If notifications are "on" an notify message will be output when they occur
          notification show (N or date) 
        Show the last N notifications or notifications from a date or all notifications"""
    if (not sp or len(sp) <= 0):
      return ""
     
    notificationsDict = modules.notificationsDict
    notify = Notification() #Singleton object
    ret = ""
     
    if len(sp) == 1:
      if (sp[0].lower() == "show"):
        ret = notify.ShowNotifications(None)
       
    elif len(sp) == 2:
      if sp[0].lower() == "show":
        ret = notify.ShowNotifications(sp[1])
      
      #enable or disable notification receiving  
      elif sp[0].lower() == "all":
        if sp[1].lower() == "on":
          notify._on = True
          notify._filter = []
           
        elif sp[1].lower() == "off":
          notify._filter = []
          for key in notificationsDict.keys():
            notify._filter.append(key)
          notify._on = False
        else:
          pass
        ret = "<text>OK</text>"
         
      # Check if this notification has been loaded
      elif sp[0] in notificationsDict:
        if sp[1].lower() == "on":
          #Remove from filter
          if (sp[0] in notify._filter):
            notify._on = True
            notify._filter.remove(sp[0])
        if sp[1].lower() == "off":
          #Add to filter list
          if (sp[0] not in notify._filter):
            notify._filter.append(sp[0])
        ret = "<text>OK</text>"
      
    else:
      ret = "<error>Command is not supported. Try 'help' for details</error>"
     
    return ret
             
  def resolveStringPathList(self,pathList):
    errors=[]
    paths = []
    for p in pathList:
      if p[0] != "/": p = os.path.join(self.context.curdir, p)
      paths.append(p)
    domLst = []
    for p in paths:
      tmp = mgtRootObject.resolvePath(p.split("/"))
      if tmp:
        domLst += tmp
      else:
        errors.append("<warning>Path [%s] is invalid</warning>" % p)
    return (domLst,errors)

  def do_diff(self,*pathList):
    """? show the differences between two object trees
       Use output redirection to place the differences into another object tree for subsequent manipulation.
       For example: diff foo bar > /tmp
    """
    outFile = None
    outLocation = None
    try:  # TODO generalize redirection feature
      pipe = pathList.index(">")
      try:
        pipeTgt = pathList[pipe+1]
      except IndexError,e:
        return "<error>Specify a file or location to pipe output</error>"
      if ".xml" in pipeTgt:
        outFile = pipeTgt
      else:
        outLocation = mgtRootObject.resolvePath(pipeTgt.split("/"))
        t = len(outLocation)
        if t==0:
          return "<error>Output location does not exist</error>"
        if t>1:
          return "<error>Path resolved to multiple locations</error>"
        outLocation=outLocation[0]
      pathList = pathList[0:pipe]  # Remove the pipe so we can use the rest of the command line to figure out what's being diffed
    except ValueError, e:  # if pathList has no >
      pass
    
    paths,errors = self.resolveStringPathList(pathList)
    if len(paths) != 2:
      errors.append("<error>Arguments resolved to incorrect number of locations.  Resolved locations are [%s]</error>" % (",".join(x.fullPath() for x in paths)))
    else: 
      c = paths[0].diff(paths[1])
      if c:
        if outFile:
          f = open(outFile,"w")
          f.write(c.prettyPrint())
          f.close()
        elif outLocation:
          outLocation.addChild(c)  
        else:
          s = c.dump()
          errors.append(s)
    tmp = "<top>" + "".join(errors) + "</top>"
    
    return tmp

  def do_copy(self,*pathList):
    """? Copy an object tree from a set of locations to another place.  If the source is a live document (the running configuration of a network element, for example), the copy will be frozen"""
    ret = []
    paths = []
    for p in pathList:
      if p[0] != "/": p = os.path.join(self.context.curdir, p)
      paths.append(p)
    dest = paths[-1]
    sources = paths[0:-1]
    domLst = []
    for p in sources:
      tmp = mgtRootObject.resolvePath(p.split("/"))
      if tmp:
        domLst += tmp
      else:
        ret.append("<warning>Path [%s] is invalid</warning>" % p)
    destElem = mgtRootObject.resolvePath(dest.split("/"))
    if not destElem:
      raise xmlterm.CommandBadArgException("Invalid destination path [%s]" % dest)
    if len(destElem)>1:
      raise xmlterm.CommandBadArgException("Destination path [%s] must resolve to a single location" % dest)
    destElem=destElem[0]
    for d in domLst:
      newElem = d.copy()
      destElem.addChild(newElem)
    return "".join(ret)
      
    

  def save_cmd(self,filename, *path):
    """? Save XML tree to disk
    <arg name="filename">File name and path to write the data</arg>
    <arg name="path">space separated list of locations to save</arg>
    <example>save ~/output.xml /local/safplusAmf/Nodes/* /local/safplusAmf/Component/myprog</example>
    """
    ret = []
    try:
      f = open(filename,"w")  # Opened first so early exception is raised if there's any problem with the file
      cwd = self.context.curdir
      if path:
        path = [ os.path.join(cwd,x) for x in path]
      else:
        raise xmlterm.CommandBadArgException("No object paths specified")
      xml=["<top>\n"]
      for p in path:  # go thru all specified paths
        domLst = mgtRootObject.resolvePath(p.split("/")) # Get all objects that this path represents 
        if domLst:
          for d in domLst: # pretty print each of those objects
            xml.append(d.prettyPrint(depth=1))
        else:
          ret.append("<warning>Path [%s] is invalid</warning>" % p)

      xml.append("</top>\n")
      f.write("".join(xml))
      ret.append("<text>File [%s] written</text>" % filename)
    finally:
      f.close()
    return "".join(ret)
    #raise xmlterm.CommandBadArgException("Specify the name of the element to be saved and the output file")
    
    

  def save_element(self,*args):
    """? Save element's configuration and/or statistics to an xml file"""
    if len(args) == 2:
      pdb.set_trace()
      elemlst = mgtRootObject.findByAttr({"listkey":args[0]})
      if not elemlst:  raise xmlterm.CommandBadArgException("Unknown Element [%s]" % args[0])
      elem = elemlst[0][1]
      elem.fetchData()
      xml = elem.prettyPrint(True)
      f = open(args[1],"w")
      f.write(xml)
      f.close()
      return "<text>File [%s] written</text>" % args[1]
    raise xmlterm.CommandBadArgException("Specify the name of the element to be saved and the output file")
      

  def add_module_cmd(self,*modulePaths):
    """? Load a YANG module"""
    global modules
    if modulePaths:
      modules.loadYangModules(modulePaths)
      return "<text>Loaded modules from [%s]</text>" % ",".join(modulePaths)
    raise xmlterm.CommandBadArgException("No path specified")

  def do_modules(self):
    """? List loaded netconf modules"""
    global modules
    ctx = modules.ctx
    ret = []
    for ((name,date),val) in ctx.modules.items():
      ret.append("<text>%s:%s</text>" % (name,date))
    return "<top>" + "".join(ret) + "</top>"
    
  def complete_connect(self):
    """Handle command line completion for the connect function"""
    pdb.set_trace()

  def do_connect(self, name, user, password, host, port=830):
        """Add a network element into the system
Arguments: name user password host [port]
  name:        Your designation for this element
  user:        username to connect to NETCONF server
  password:    password to connect to NETCONF server
  host:        FQDN or IP address of NETCONF server
  port:        port to connect to
"""
        
        if name == None:
            print "Invalid parameter. Name is NULL"
            return

        if host == None:
            print "Invalid parameter. Host is NULL"
            return

        serverObject = mgtRootObject.child_.get(name)

        isServExist = True

        if serverObject is  None:
            serverObject = mgtserver.MgtServerObject(mgtRootObject,{ "listkey": name}, [], [], modules)
            isServExist = False

        serverObject.updateData(name, host, port, user, password) 

        if serverObject.connected:
            serverObject.disconnect()

        serverObject.connect()

        if (isServExist == False):
            mgtRootObject.addChild(serverObject)
        return ""



def isValidDirectory(path):
    tmp = mgtGet("{n=0}" + path)
    if tmp.startswith("<error>"):
      return False
    return True


def yangGetFullPath(stmt):
  """returns the full xpath of a particular statement"""
  pathsep = "/"
  path = stmt.arg
  while stmt.parent is not None:
    stmt = stmt.parent
    if stmt.arg is not None and stmt.keyword != 'module':
      path = stmt.arg + pathsep + path
  return path


class YangModules:
  def __init__(self,moduleDirList=None):
    self.repos = pyang.FileRepository()
    self.ctx = pyang.Context(self.repos)
    self.mapKeyList = {}
    # Build keys for list. So CLI can identity a node in a list
    self.mapKeyRpc = {} # rpc command and namespace
    if moduleDirList:
      self.loadYangModules(moduleDirList)

  def yangStatements(self,stmts):
#    print stmts
    for s in stmts:
      if s.keyword == 'rpc':
        if s.arg not in self.mapKeyRpc:
          print s.arg
          self.mapKeyRpc[s.arg] = s
      elif s.keyword == 'list' and s.search_one('key') is not None:
        self.mapKeyList[yangGetFullPath(s)] = s.search_one('key').arg.split()
      if s.substmts:
        self.yangStatements(s.substmts)

  def yangModuleRecursiveParser(self,direc):
    # logging.debug("Loading YANG from: %s " % str(direc))      
    r = re.compile(r"^(.*?)(\@(\d{4}-\d{2}-\d{2}))?\.(yang|yin)$")
    m = r.search(direc)
    if m is not None:
        (name, _dummy, rev, format) = m.groups()
        name = os.path.basename(name)
        try:
            fd = open(direc)
            text = fd.read()
        except IOError as ex:
            sys.stderr.write("error %s: %s\n" % (direc, str(ex)))
            return
        logging.debug("Loading: %s/%s " % (str(direc),str(name)))  
        self.ctx.add_module(direc, text, format, name, rev, expect_failure_error=False)
        # GAS BROKEN self.loadRpcCommands(text)
      
    else:
        try:
            children = os.listdir(os.path.abspath(direc))
        except OSError:
            children = []

        for d in children:
            self.yangModuleRecursiveParser(os.path.join(direc, d))

  def loadYangModules(self,dirList):
    """Loads all the YANG modules from the supplied directories"""
    for d in dirList:
      if isinstance(d, tuple) or isinstance(d, list):
          self.loadYangModules(d)
      else:
          self.yangModuleRecursiveParser(d)

    # Now create the list to key mapping 
    for module in self.ctx.modules.items():
      self.yangStatements(module[1].substmts)

def networkElementHandler(elem, resolver,context):
  """Convert an xml leaf containing a network element description to a window"""
  
  fore = None
  if elem.attrib["status"] == "connected":
    fore = NetworkElementConnectedColor
  elif elem.attrib["status"] == "disconnected":
    fore = NetworkElementDisconnectedColor
  text = "%s (%s)" % (elem.attrib["listkey"],elem.attrib.get("fqdn",""))
  w = xmlterm.FancyText(resolver.parentWin, ("  "*resolver.depth) + text,fore=fore)
  resolver.add(w)  

  resolver.depth += 1
  context.path.append(elem.tag)
  for child in elem:
    resolver.resolve(child,context)
    if child.tail and child.tail.strip():
      w = xmlterm.FancyTextChunked(resolver.parentWin,("  "*resolver.depth) + child.tail,chunkSize=2048)
      resolver.add(w)
  del context.path[-1]   
  resolver.depth -= 1

def rpcErrorHandler(elem, resolver,context):
  """Convert an rpc error xml to a window"""
  tag = elem.tag
  if elem.tag[0] == "{": 
    namespace, tag = elem.tag[1:].split("}")

  w = xmlterm.FancyText(resolver.parentWin, ("  "*resolver.depth) + tag, fore=(0xff,0,0))
  resolver.add(w)

  resolver.depth += 1
  context.path.append(elem.tag)
  for child in elem:
    resolver.resolve(child,context)

  del context.path[-1]   
  resolver.depth -= 1


def Initialize(moduleSearchPath=None):
  global mgtRootObject,modules
  mgtRootObject = mgtobject.MgtRootObject({ "tag_": "top"}, [], [])  

  if moduleSearchPath is None:
    moduleSearchPath=[]

  module_path = os.getenv('YUMA_HOME')
  if module_path is not None:
      moduleSearchPath += module_path.split(":")

  module_path = os.getenv('YANG_MODPATH')
  if module_path is not None:
      moduleSearchPath += module_path.split(":")

  module_path = os.getenv('SAFPLUS_MODULES_PATH')
  if module_path is not None:
      moduleSearchPath += module_path.split(":")
      
  moduleSearchPath.append(os.path.abspath(os.path.join(os.path.dirname(__file__),"yang")))  # Also look in: <this script's directory>/yang
  logging.debug("Loading YANG from: %s " % str(moduleSearchPath))
 
  modules = YangModules(moduleSearchPath)

  handlers = {"networkElement": networkElementHandler,
              "urn:ietf:params:xml:ns:netconf:base:1.0": {"rpc-error": rpcErrorHandler,}
              }
  cmds= Commands()
  ret = (cmds,handlers)
  for key in modules.mapKeyRpc:
    if not key in ("delete","create","replace","merge"):
      cmds.commands[key]=(cmds.handleRpc, None)

  # Temporary
  #ret[0].add_module_cmd("/code/git/SAFplus7/src/yang")
  #ret[0].do_connect("local","root","qwerty","localhost")
  return ret 


def isListElem(elem,path):
  # TODO: replace with code that looks this up in the object tree or in the yang definition
  #print elem.tag, path
  # pdb.set_trace()
  (mod,tag) = (None,elem.tag)
  if elem.tag[0] == "{":
    (mod,tag) = elem.tag.split("}")
    mod = mod[1:] # because the split made it into "{foo"

  t = path[2:]  # path looks like ["","<Machine>", "now","the", "actual","xpath"]
  if path[-1] != tag: t.append(tag)   # Add the elem onto the path, unless (in the list case) the user has already "cd"ed into it
  xpath = "/".join(t)  

  listKey = modules.mapKeyList.get(xpath,None)
  if listKey is not None:
    keyelem = elem.find(listKey[0])  # TODO: right now, we designate the 'name' used by this CLI to be the first key, but allowing multiple names would be great
    if keyelem is not None:
      if keyelem.text:
        elem.attrib["listkey"] = keyelem.text
        if elem.find("more") is not None:  # If this is not listing children, then I need to remove the keyelem child now that I've stored it as an attribute for good-looking display
          elem.remove(keyelem)
 
    return tag

  return None

def mgtGet(xpath):
  #print xpath
  xpl = xpath.split("/")
  depth=16
  if xpl[0][0] == "{":  # TODO, interprete these custom commands if possible in netconf
     args = xpl[0][1:-1].split(",") # [1:-1] chops off the surrounding {}
     for a in args:
       if a[0]=="d":
         (d,depthStr) = a.split("=")
         depth = int(depthStr)
  elif xpl[0] != '':  # xpath does not begin with a / but relative paths should be resolved in higher layer SW because there is not concept of current dir here
    print "Path is: %s" % str(xpl)
    assert(0)
  xml = mgtRootObject.resolvePathToXml(xpl[1:],depth)
  return xml




def Test():
  Initialize(["../../../SAFplus7/src/yang"])
  #do_add_element("local","root","qwerty","localhost")
  #pdb.set_trace()
  mgtGet("{n}/local/subscribers")

  #mgtGet("{d=1}/")  # Should return the list of servers 
  #mgtGet("{d=1}/local")  # Should return just the top level "directory" of the server named "local"
