###############################################################################
#
# Copyright (C) 2002-2009 by OpenClovis Inc. All  Rights Reserved.
# 
# The source code for  this program is not published  or otherwise 
# divested of  its trade secrets, irrespective  of  what  has been 
# deposited with the U.S. Copyright office.
# 
# This program is  free software; you can redistribute it and / or
# modify  it under  the  terms  of  the GNU General Public License
# version 2 as published by the Free Software Foundation.
# 
# This program is distributed in the  hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied  warranty  of 
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
# General Public License for more details.
# 
# You  should  have  received  a  copy of  the  GNU General Public
# License along  with  this program. If  not,  write  to  the 
# Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
#
###############################################################################

def do_show_by_name(self,arg):
    """location: **/interfaces"""
    ne = self.networkElement()
    if ne:
      arg = ne.getName() + "/ethernet/interfaces[ename=" + arg + "]"
    else:
      for ne in self.getChildren():  # Get list of ALL network interfaces
          do_show_by_name(ne,arg)
    target = self.getByPath(arg, 'interfaces')

    """ Code to show interface here """
    if target is None:
        print "Target not found"
        return

    print "show interface: [%s]" %target.name.data_

def do_show_by_path(self,arg):
    """location: **/interfaces"""
    target = self.getByPath(arg, 'interfaces')

    """ Code to show interface here """
    if target is None:
        print "Target not found"
        return

    print "show interface: [%s]" %target.name.data_

def complete_show_by_path(self, text, line, begidx, endidx):
    return self.process(text)

def do_printstate(self, arg):
    """location: **/disk"""
    target = self.getByPath(arg, 'disk')

    """ Code to print disk state here """
    if target is None:
        print "Target not found"
        return

    print "Disk drive state"

def do_LeastLoadedElement(self, arg):
    servers=self.getElementList()
    loadAmts = []
    for s in servers:
        loadXml = s.getByPath("statistics/cpuload")
        if loadXml is not None:
            loadAmts.append([s.name,float(loadXml.data_)])

    if len(loadAmts) > 0:
        loadAmts.sort(key=lambda x: x[1])
        print loadAmts[0][0]

