#pragma once
#ifndef MGTCLIENT_HXX_
#define MGTCLIENT_HXX_

#ifdef __cplusplus
extern "C"
{
#endif
#include <stdio.h>
#include <string.h>
#include <libssh/libssh.h>
#include <libssh/callbacks.h>
#ifdef __cplusplus
}
#endif
#include <mutex>
#include <thread>
#include <chrono>
#include <functional>
#include <boost/algorithm/string.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/date_time/local_time/local_date_time.hpp>
#include <boost/date_time.hpp>
#include <locale>
#include <clCommon6.h>
#include <clCommonErrors6.h>
#include <clMgtBaseCommon.hxx>
#include <clLogApi.hxx>

const int MAXBUFF = 4096;
const int MAXCOUNTWAIT = 10;
static std::string strHello = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:hello xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\"><nc:capabilities><nc:capability>urn:ietf:params:netconf:capability:writable-running:1.0</nc:capability><nc:capability>urn:ietf:params:netconf:capability:rollback-on-error:1.0</nc:capability><nc:capability>urn:liberouter:params:netconf:capability:power-control:1.0</nc:capability><nc:capability>urn:ietf:params:netconf:capability:validate:1.0</nc:capability><nc:capability>urn:ietf:params:netconf:capability:confirmed-commit:1.0</nc:capability><nc:capability>urn:ietf:params:netconf:capability:url:1.0?scheme=http,ftp,file,https,sftp</nc:capability><nc:capability>urn:ietf:params:netconf:base:1.0</nc:capability><nc:capability>urn:ietf:params:netconf:base:1.1</nc:capability><nc:capability>urn:ietf:params:netconf:capability:candidate:1.0</nc:capability><nc:capability>urn:ietf:params:netconf:capability:notification:1.0</nc:capability><nc:capability>urn:ietf:params:netconf:capability:xpath:1.0</nc:capability><nc:capability>urn:ietf:params:netconf:capability:startup:1.0</nc:capability><nc:capability>urn:ietf:params:netconf:capability:interleave:1.0</nc:capability></nc:capabilities></nc:hello>]]>]]>\n";
static std::string strGetConfig = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:get-config><nc:source><nc:%s/></nc:source>%s</nc:get-config></nc:rpc>";
static std::string strSetConfig = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:edit-config><nc:trans-id>%lu</nc:trans-id><nc:target><nc:%s/></nc:target><config>%s</config></nc:edit-config></nc:rpc>";
static std::string strCreateConfig = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:edit-config><nc:trans-id>%lu</nc:trans-id><nc:target><nc:%s/></nc:target><config>%s</config></nc:edit-config></nc:rpc>";
static std::string strRPC = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><%s %s>%s</%s></nc:rpc>";
static std::string strCreateSubscriber = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><create-subscription xmlns=\"urn:ietf:params:xml:ns:netconf:notification:1.0\"><stream>NETCONF</stream>%s%s</create-subscription></nc:rpc>";
static std::string strGetTrans = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:trans-start><nc:target><nc:%s/></nc:target></nc:trans-start></nc:rpc>";
static std::string strTransRollBack = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:trans-rollback><nc:trans-id>%lu</nc:trans-id></nc:trans-rollback></nc:rpc>";
static std::string strTransCommit = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:trans-commit><nc:trans-id>%lu</nc:trans-id></nc:trans-commit></nc:rpc>";
static std::string strCommit = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:commit/></nc:rpc>";
static std::string strLock = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:lock><nc:target><nc:%s/></nc:target></nc:lock></nc:rpc>";
static std::string strUnLock = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:unlock><nc:target><nc:%s/></nc:target></nc:unlock></nc:rpc>";
static std::string strDiscardChange = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:discard-changes/></nc:rpc>";
static std::string strSetLogLevel = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><set-log-level xmlns=\"http://netconfcentral.org/ns/yuma-system\"><log-level>%s</log-level></set-log-level></nc:rpc>";
static std::string strCopyConfig = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><nc:rpc xmlns:nc=\"urn:ietf:params:xml:ns:netconf:base:1.0\" message-id=\"%s\"><nc:copy-config><nc:source><nc:%s/></nc:source><nc:target><nc:%s/></nc:target></nc:copy-config></nc:rpc>";

class MgtClient
{
private:
  std::mutex mutex_data;
  int timeOut;//unit milisecond
  bool isRunning;//true:running,false:candidate
  bool isConnected;//Connected
  bool isDataAvailable;//data is available in xmlObj
  xmlParser xmlObj;//object parser
  ssh_session session_data;//session for data
  ssh_channel channel_data;//channel for data
  std::string strUserName;//user name
  std::string strPassWord;//password
  std::string strIpAddress;//ip server
  std::string strNameSpace;//namespace
  int iPort;//port
  uint64_t messageId;//identify message
  std::string strDatabase;//database name
  uint64_t currentTransactionId;//current transaction
  std::function<void(void*)> cbNotification;//call back function
  ClRcT Connect(ssh_session& psession, ssh_channel& pchannel);
  ClRcT Close(ssh_session& psession, ssh_channel& pchannel);
  ssh_session session_subscriber;//session for subscriber
  ssh_channel channel_subscriber;//channel for subscriber
  bool isSubscriber;//already Subscriber
  bool isFinishSubscriber;//true: already subsriber, false: not subscriber or not finish
  std::thread threadSubscriber;//thread to receive subscriber
  int verbosity = 1;
  /*check is notification messsage*/
  bool IsNotification(void* data);
  /*send hello message to server*/
  void SendHelloMessage(ssh_channel& pchannel);
  /*function listener subscriber*/
  void funcSubscriber();
  /*Execute RPC: tagInValue: RPC format message*/
  ClRcT ExecRpc(const std::string& tagInValue);
  /*Execute RPC: tagInValue: RPC format message, strOutput: result return message*/
  ClRcT ExecRpc(const std::string& tagInValue, std::string& strOutput);

public:
  /*constructor*/
  MgtClient(const std::string& puserName, const std::string& ppassWord, const std::string& pipAddress = "127.0.0.1", const int& pport = 830,
      const bool& pisRunning = true);
  /*Get isConnect*/
  bool GetIsConnect();
  /*Get isRuning*/
  bool GetIsRunning();
  /*Set timeout for entire connnection*/
  void SetTimeOut(const int& ptimeOut = 1000);//milisecond
  /*Get timeout*/
  int GetTimeout();//milisecond
  /*Connect to server*/
  ClRcT Connect();
  /*Transaction operation*/
  ClRcT TransStart(uint64_t& transId);
  /*Get Transaction Id*/
  uint64_t GetTransId();
  /*Transaction roll back*/
  ClRcT TransRollback(const uint64_t& transId);
  /*Transaction commit*/
  ClRcT TransCommit(const uint64_t& transId);
  /*Create subscriber
   *strPath: string of path subscriber
   *startTime: start of time
   *pcbNotification: callback function
   *return : CL_OK is success,else failed
   */
  ClRcT Subscriber(const std::string& strPath, boost::posix_time::ptime startTime, std::function<void(void*)> pcbNotification);
  /*Create subscriber
   *strPath: string of path subscriber
   *startTime: start of time
   *stopTime: stop of time
   *pcbNotification: callback function
   *return : CL_OK is success,else failed
   */
  ClRcT Subscriber(const std::string& strPath, boost::posix_time::ptime startTime, boost::posix_time::ptime stopTime,
      std::function<void(void*)> pcbNotification);
  /*Create subscriber
   *strPath: string of path subscriber
   *startTime: start of time
   *stopTime: stop of time
   *pcbNotification: callback function
   *return : CL_OK is success,else failed
   */
  ClRcT Subscriber(const std::string& strPath, std::function<void(void*)> pcbNotification);
  /*Create subscriber
   *strPath: string of path subscriber
   *startTime: string start of time
   *stopTime: string stop of time
   *pcbNotification: callback function
   *return : CL_OK is success,else failed
   */
  ClRcT Subscriber(const std::string& strPath, const std::string& strStartTime, const std::string& strStopTime, std::function<void(void*)> pcbNotification);
  /*UnSubscribe*/
  ClRcT UnSubscriber();
  /*GetConfigXpath
   *strFilter: string of path filter
   *outValue: result return
   *isXpath: xpath format type if true, else subtree
   *return : CL_OK is success,else failed
   */
  ClRcT GetConfig(const std::string& strFilter, std::string& outValue, const bool& isXpath = true);
  /*GetConfigXpath
   *strFilter: string of path filter
   *databaseName: candidate/running
   *outValue: result return
   *isXpath: xpath format type if true, else subtree
   *return : CL_OK is success,else failed
   */
  ClRcT GetConfig(const std::string& strFilter, const std::string& databaseName, std::string& outValue, const bool& isXpath = true);
  /*Checks existense of an object. Leafs in the data model may be optional, and presence containers and list entries may or may not exist.
   This function checks whether a node exists in database, return true if it exists, return false if not*/
  bool IsExist(const std::string& strPath);
  bool IsExist(const std::string& strPath, const std::string& databaseName);
  /*Returns all the values in a container or list entry*/
  ClRcT GetObject(const std::string& strPath, std::string& tagOutValue);
  ClRcT GetObject(const std::string& strPath, const std::string& databaseName, std::string& tagOutValue);
  /*Write an entire object, i.e. YANG list entry or container
   *strPath: path
   *tagInValue: xml format attribute
   *transId: transaction id
   */
  ClRcT SetObject(const std::string& strPath, const std::string& tagInValue, const uint64_t& transId = 0);
  /*Set namespace for next rpc*/
  void SetNameSpace(const std::string& pstrNameSpace);
  /*Do RPC
   *rpcName: string rpc name
   *tagInValue: xml format value
   *strOutput: result output
   *return CL_OK: if success,else: failed
   */
  ClRcT DoRpc(const std::string& rpcName, const std::string& tagInValue, std::string& strOutput);
  /*Lock database
   *strTargetDatabase: database name: candidate,running
   *return CL_OK if success, else: failed
   */
  ClRcT Lock(const std::string& strTargetDatabase);
  /*UnLock database
   *strTargetDatabase: database name: candidate,running
   *return CL_OK if success, else: failed
   */
  ClRcT UnLock(const std::string& strTargetDatabase);
  /*Discard change
   *return CL_OK if success, else: failed
   */
  ClRcT DiscardChange();
  /*SetLogLevel
   *logLevel: log level
   *return CL_OK if success, else: failed
   */
  ClRcT SetLogLevel(const SAFplus::LogSeverity& logLevel);
  /*Copy config
   *srcDatabase: source database name: candidate,running
   *destDatabase: destination database name: candidate,running
   *return CL_OK if success, else: failed
   */
  ClRcT CopyConfig(const std::string& srcDatabase, const std::string& destDatabase);
  /*Commit RPC
   *return CL_OK if success, else: failed
   */
  ClRcT Commit();
  /* Close Connection*/
  ClRcT Close();
  /* Destructor*/
  ~MgtClient();
  /*Generate new messageId
   *return: new message id
   */
  std::string GenerateMessageId();
  /*Get messageId
   *return: message id
   */
  std::string GetMessageId();
  /*Read an element
   *strPath: path to element
   *outValue: value output
   *return: CL_OK if success, else: failed
   */
  template<typename T> ClRcT GetElement(const std::string& strPath, T & outValue, const bool& isUpdate = true)
  {
    return GetElement(strPath, strDatabase, outValue, isUpdate);
  }
  /*Read an element
   *strPath: path to element
   *outValue: value output
   *databaseName: candidate/running
   *return: CL_OK if success, else: failed
   */
  template<typename T> ClRcT GetElement(const std::string& strPath, const std::string& databaseName, T & outValue, const bool& isUpdate = true)
  {
    std::string strResult;
    std::string strTemp = strPath;
    if (!isConnected)
    {
      logError("MGT", "NC", "Not connected!");
      return CL_ERR_UNSPECIFIED;
    }
    if (strPath.length() == 0)
    {
      logError("MGT", "NC", "Path is empty");
      return CL_ERR_UNSPECIFIED;
    }
    if (!isDataAvailable || isUpdate)
    {
      isDataAvailable = false;
      if (CL_OK != GetConfig(strPath, databaseName, strResult)) return CL_ERR_UNSPECIFIED;
    }
    boost::replace_all(strTemp, "\\", ".");
    try
    {
      outValue = xmlObj.getValue < T > (strTemp);
    }
    catch (std::exception& ex)
    {
      return CL_ERR_UNSPECIFIED;
    }
    return CL_OK;
  }
  /*Create an element
   *tValue: value input
   *return: CL_OK if success, else: failed
   */
  template<typename T> ClRcT CreateElement(const std::string& strPath, const T& tValue, const uint64_t& transId = 0)
  {
    std::lock_guard <std::mutex> lock(mutex_data);
    char buffer[MAXBUFF];
    if (strNameSpace.length() == 0)
    {
      logError("MGT", "NC", "NameSpace is empty");
      return CL_ERR_UNSPECIFIED;
    }
    if (strPath.length() == 0)
    {
      logError("MGT", "NC", "Path is empty");
      return CL_ERR_UNSPECIFIED;
    }
    memset(buffer, 0, MAXBUFF);
    std::string strXmlContent = path2xml < T > (strPath, tValue, strNameSpace, NCOPERATION::Create, false);
    sprintf(buffer, strCreateConfig.c_str(), GetMessageId().c_str(), transId, strDatabase.c_str(), strXmlContent.c_str());
    return ExecRpc(buffer);
  }
  /*Delete an element
   *tValue: value input
   *return: CL_OK if success, else: failed
   */
  template<typename T> ClRcT DeleteElement(const std::string& strPath, const T& tValue, const uint64_t& transId = 0)
  {
    std::lock_guard <std::mutex> lock(mutex_data);
    if (strNameSpace.length() == 0)
    {
      logError("MGT", "NC", "NameSpace is empty");
      return CL_ERR_UNSPECIFIED;
    }
    if (strPath.length() == 0)
    {
      logError("MGT", "NC", "Path is empty");
      return CL_ERR_UNSPECIFIED;
    }
    char buffer[MAXBUFF];
    memset(buffer, 0, MAXBUFF);
    std::string strXmlContent = path2xml < T > (strPath, tValue, strNameSpace, NCOPERATION::Delete, false);
    sprintf(buffer, strCreateConfig.c_str(), GetMessageId().c_str(), transId, strDatabase.c_str(), strXmlContent.c_str());
    return ExecRpc(buffer);
  }
  /*Set an element
   *strPath: string path
   *tValue: value input
   *transId: transaction id
   *return: CL_OK if success, else: failed
   */
  template<typename T> ClRcT SetElement(const std::string& strPath, const T& tValue, const uint64_t& transId = 0)
  {
    std::lock_guard <std::mutex> lock(mutex_data);
    if (strPath.length() == 0)
    {
      logError("MGT", "NC", "Path is empty");
      return CL_ERR_UNSPECIFIED;
    }
    char buffer[MAXBUFF];
    memset(buffer, 0, MAXBUFF);
    std::string strXmlContent = path2xml < T > (strPath, tValue, false);
    sprintf(buffer, strSetConfig.c_str(), GetMessageId().c_str(), transId, strDatabase.c_str(), strXmlContent.c_str());
    return ExecRpc(buffer);
  }
};

#endif /* MGTCLIENT_HXX_ */
