/******Discard-change fail when another client locking database******/

#include <iostream>
#include <clDbalBase.hxx>
#include <clTestApi.hxx>
#include <mgtclient.hxx>

using namespace SAFplus;
#define clprintf(sev,...) SAFplus::logMsgWrite(SAFplus::APP_LOG, sev, 0, "APP", "MAIN", __FILE__, __LINE__, __VA_ARGS__)

void callbackfunction(void*data)
{
  std::cout << "callbackfunction exec:\n*******************************************************************\n" << (char*) data << std::endl;
  std::cout << "*******************************************************************\n";
}

void testDiscard();
void testLock();

bool isRunning = false;
MgtClient client1("root", "root", "127.0.0.1", 830, isRunning);
MgtClient client2("root", "root", "127.0.0.1", 830, isRunning);
int main(void)
{
  SAFplus::logSeverity = SAFplus::LOG_SEV_DEBUG;
  clTestGroupInitialize(("MGT-MGTCLIENT: Discard-Change"));
  ClRcT rc = CL_OK;

  // Create 2 client
  rc = client1.Connect();
  rc = client2.Connect();
  clTest(("Opening database is "), rc == CL_OK, (("rc is %x"), rc));
  client1.SetNameSpace("xmlns=\"http://www.myCompany.com/ns/myService\"");
  client1.GenerateMessageId();
  client2.SetNameSpace("xmlns=\"http://www.myCompany.com/ns/myService\"");
  client2.GenerateMessageId();
  ////////////////////////////////////////////////////////////

  testLock();
  testDiscard();

  sleep(5);
  ///////////////////////////////////////////////////////////
  client1.Close();
  client2.Close();
  clTestGroupFinalize();
  return 0;
}

void testDiscard()
{
  ClRcT rc = client2.DiscardChange();
  clTest(("DiscardChange fail!"), rc == CL_ERR_UNSPECIFIED, ("DiscardChange success!"));
  if (CL_OK == rc)
  {
    logInfo("DBAL","TEST","Result: DiscardChange success!");
  } else
  {
    logInfo("DBAL","TEST","Result: DiscardChange fail!\n");
  }
}

void testLock()
{
  ClRcT rc = client1.Lock("running");
  clTest(("Lock success!"), rc == CL_OK, ("Lock fail!"));
  if (CL_OK == rc)
  {
    logInfo("DBAL","TEST","Result: Lock database is success!");
  } else
  {
    logInfo("DBAL","TEST","Result: Lock database is fail!");
  }
}


