/**************************************************
 *                                                *
 ****Abnormal case when execute delete element*****
 *                                                *
 *************************************************/

#include <iostream>
#include <clDbalBase.hxx>
#include <clTestApi.hxx>
#include <mgtclient.hxx>

using namespace SAFplus;
#define clprintf(sev,...) SAFplus::logMsgWrite(SAFplus::APP_LOG, sev, 0, "APP", "MAIN", __FILE__, __LINE__, __VA_ARGS__)


void callbackfunction(void*data)
{
  std::cout << "callbackfunction exec:\n*******************************************************************\n" << (char*) data << std::endl;
  std::cout << "*******************************************************************\n";
}

void testDelete();

bool isRunning = true;
MgtClient client("root", "root", "127.0.0.1", 830, isRunning);
int main(void)
{
  SAFplus::logSeverity = SAFplus::LOG_SEV_DEBUG;
  clTestGroupInitialize(("MGT-MGTCLIENT: Abnormal case when execute delete element"));
  ClRcT rc = CL_OK;
  rc = client.Connect();
  clTest(("Opening database is "), rc == CL_OK, (("rc is %x"), rc));
  client.SetNameSpace("xmlns=\"http://www.myCompany.com/ns/myService\"");
  client.GenerateMessageId();
  ////////////////////////////////////////////////////////////
  testDelete();
  sleep(5);
  ///////////////////////////////////////////////////////////
  client.Close();
  clTestGroupFinalize();
  return 0;
}
void testDelete()
{
  ClRcT rc = CL_OK;
  std::string strPath;
  std::string strElement;

  // path is wrong
  strPath = "myService\\subscribers";
  strElement = "<name>host2</name>";
  std::cout << "Delete element with path is wrong..." << std::endl;
  rc = client.DeleteElement<std::string>(strPath, strElement);
  clTest(("DeleteElement is fail!"), rc == CL_ERR_UNSPECIFIED, ("DeleteElement is success!"));
  if(rc == CL_ERR_UNSPECIFIED)
  {
    logInfo("DBAL","TEST","Result: DeleteElement is fail!");
  }
  else
  {
    logInfo("DBAL","TEST","Result: DeleteElement is success!");
  }

  // commit if mode = candidate
  if (!isRunning)
  {
    sleep(1);
    rc = client.Commit();
    clTest(("Commit is "), rc == CL_OK, ("rc is %x", rc));
  }

  // path is null
  strPath = "";
  strElement = "<name>host2</name>";
  std::cout << "Delete element with path is null..." << std::endl;
  rc = client.DeleteElement<std::string>(strPath, strElement);
  clTest(("DeleteElement is fail!"), rc == CL_ERR_UNSPECIFIED, ("DeleteElement is success!"));
  if(rc == CL_ERR_UNSPECIFIED)
  {
    logInfo("DBAL","TEST","Result: DeleteElement is fail!");
  }
  else
  {
    logInfo("DBAL","TEST","Result: DeleteElement is success!");
  }

  // commit if mode = candidate
  if (!isRunning)
  {
    sleep(1);
    rc = client.Commit();
    clTest(("Commit is "), rc == CL_OK, ("rc is %x", rc));
  }

  // element is null
  strPath = "myService\\subscribers\\subscriber";
  strElement = "";
  std::cout << "Delete element with element is null..." << std::endl;
  rc = client.DeleteElement<std::string>(strPath, strElement);
  clTest(("DeleteElement is fail!"), rc == CL_ERR_UNSPECIFIED, ("DeleteElement is success!"));
  if(rc == CL_ERR_UNSPECIFIED)
  {
    logInfo("DBAL","TEST","Result: DeleteElement is fail!");
  }
  else
  {
    logInfo("DBAL","TEST","Result: DeleteElement is success!");
  }

  // commit if mode = candidate
  if (!isRunning)
  {
    sleep(1);
    rc = client.Commit();
    clTest(("Commit is "), rc == CL_OK, ("rc is %x", rc));
  }
}
