/**************************************************
 *                                                *
 *****Get config successfully when path is null****
 *                                                *
 *************************************************/

#include <iostream>
#include <clDbalBase.hxx>
#include <clTestApi.hxx>
#include <mgtclient.hxx>

using namespace SAFplus;
#define clprintf(sev,...) SAFplus::logMsgWrite(SAFplus::APP_LOG, sev, 0, "APP", "MAIN", __FILE__, __LINE__, __VA_ARGS__)


void callbackfunction(void*data)
{
  std::cout << "callbackfunction exec:\n*******************************************************************\n" << (char*) data << std::endl;
  std::cout << "*******************************************************************\n";
}

void testGetConfig();

bool isRunning = true;
MgtClient client("root", "root", "127.0.0.1", 830, isRunning);
int main(void)
{
  SAFplus::logSeverity = SAFplus::LOG_SEV_DEBUG;
  clTestGroupInitialize(("MGT-MGTCLIENT: Get config successfully when path is null"));
  ClRcT rc = CL_OK;
  rc = client.Connect();
  clTest(("Opening database is "), rc == CL_OK, (("rc is %x"), rc));
  client.SetNameSpace("xmlns=\"http://www.myCompany.com/ns/myService\"");
  client.GenerateMessageId();
  ////////////////////////////////////////////////////////////

  testGetConfig();
  sleep(5);
  ///////////////////////////////////////////////////////////

  client.Close();
  clTestGroupFinalize();
  return 0;
}

void testGetConfig()
{
  std::string strResult;
  std::string strPath = "";
  ClRcT rc = client.GetConfig(strPath, strResult);
  clTest(("GetConfig is success!"), rc == CL_OK, ("GetConfig is fail!"));
  if (CL_OK == rc)
  {
    std::cout << "Result:" << strResult << std::endl;
    logInfo("DBAL","TEST","Result: GetConfig is success!");
  } else
  {
    std::cout << "GetConfig is fail!\n";
  }
}
