/******Create element successfully after unlock database******/

#include <iostream>
#include <clDbalBase.hxx>
#include <clTestApi.hxx>
#include <mgtclient.hxx>

using namespace SAFplus;
#define clprintf(sev,...) SAFplus::logMsgWrite(SAFplus::APP_LOG, sev, 0, "APP", "MAIN", __FILE__, __LINE__, __VA_ARGS__)

void callbackfunction(void*data)
{
  std::cout << "callbackfunction exec:\n*******************************************************************\n" << (char*) data << std::endl;
  std::cout << "*******************************************************************\n";
}

void testLockUnlockDatabase();
bool isRunning = true;
MgtClient client1("root", "root", "127.0.0.1", 830, isRunning);
MgtClient client2("root", "root", "127.0.0.1", 830, isRunning);
int main(void)
{
  SAFplus::logSeverity = SAFplus::LOG_SEV_DEBUG;
  clTestGroupInitialize(("MGT-MGTCLIENT: Create element successfully after unlock database"));
  ClRcT rc = CL_OK;

  // Create 2 client
  rc = client1.Connect();
  rc = client2.Connect();
  clTest(("Opening database is "), rc == CL_OK, (("rc is %x"), rc));
  client1.SetNameSpace("xmlns=\"http://www.myCompany.com/ns/myService\"");
  client1.GenerateMessageId();
  client2.SetNameSpace("xmlns=\"http://www.myCompany.com/ns/myService\"");
  client2.GenerateMessageId();
  ////////////////////////////////////////////////////////////

  testLockUnlockDatabase();

  sleep(5);
  ///////////////////////////////////////////////////////////
  client1.Close();
  client2.Close();
  clTestGroupFinalize();
  return 0;
}

void testLockUnlockDatabase()
{
  ClRcT rc = CL_OK;
  //Client 1 lock database
  rc = client1.Lock("running");
  clTest(("Lock success!"), rc == CL_OK, ("Lock fail!"));
  if (CL_OK == rc)
  {
    logInfo("DBAL","TEST","Result: Lock database is success!");
  } else
  {
    logInfo("DBAL","TEST","Result: Lock database is fail!");
  }

  // Client 1 unlock database
  rc = client1.UnLock("running");
  clTest(("UnLock success!"), rc == CL_OK, ("UnLock fail!"));
  if (CL_OK == rc)
  {
    logInfo("DBAL","TEST","Result: UnLock database is success!");
  } else
  {
    logInfo("DBAL","TEST","Result: UnLock database is fail!");
  }

  // Client2 create host in subscriber
  std::string strPath = "myService\\subscribers\\subscriber";
  std::string strElement = "<name>host4</name>";
  rc = client2.CreateElement<std::string>(strPath, strElement);
  clTest(("CreateElement success!"), rc == CL_OK, ("CreateElement fail!"));
  if (CL_OK == rc)
  {
    logInfo("DBAL","TEST","Result: CreateElement is success!");
  } else
  {
    logInfo("DBAL","TEST","Result: CreateElement is failed\n");
  }
}
