/******Get config fail when another client don't commit transaction******/

#include <iostream>
#include <clDbalBase.hxx>
#include <clTestApi.hxx>
#include <mgtclient.hxx>

using namespace SAFplus;
#define clprintf(sev,...) SAFplus::logMsgWrite(SAFplus::APP_LOG, sev, 0, "APP", "MAIN", __FILE__, __LINE__, __VA_ARGS__)

void callbackfunction(void*data)
{
  std::cout << "callbackfunction exec:\n*******************************************************************\n" << (char*) data << std::endl;
  std::cout << "*******************************************************************\n";
}

void testTransaction();
bool isRunning = true;
MgtClient client1("root", "root", "127.0.0.1", 830, isRunning);
MgtClient client2("root", "root", "127.0.0.1", 830, isRunning);
int main(void)
{
  SAFplus::logSeverity = SAFplus::LOG_SEV_DEBUG;
  clTestGroupInitialize(("MGT-MGTCLIENT: Transaction"));
  ClRcT rc = CL_OK;

  // Create 2 client
  rc = client1.Connect();
  rc = client2.Connect();
  clTest(("Opening database is "), rc == CL_OK, (("rc is %x"), rc));
  client1.SetNameSpace("xmlns=\"http://www.myCompany.com/ns/myService\"");
  client1.GenerateMessageId();
  client2.SetNameSpace("xmlns=\"http://www.myCompany.com/ns/myService\"");
  client2.GenerateMessageId();
  ////////////////////////////////////////////////////////////

  testTransaction();

  sleep(5);
  ///////////////////////////////////////////////////////////
  client1.Close();
  client2.Close();
  clTestGroupFinalize();
  return 0;
}

void testTransaction()
{
  ClRcT rc = CL_OK;
  // Start transaction
  uint64_t transId;
  rc = client1.TransStart(transId);
  clTest(("Transaction start success!"), rc == CL_OK, ("Transaction start fail!"));
  if (CL_OK == rc)
  {
    std::cout << "Transid from server success:" << transId << std::endl;
    logInfo("DBAL","TEST","Result: Transaction start is success!");
  } else
  {
    logInfo("DBAL","TEST","Result: Transaction start is fail!\n");
    return;
  }

  // Client2 get config
  std::string strResult;
  rc = client2.GetConfig("myService", strResult);
  clTest(("GetConfig fail!"), rc == CL_ERR_UNSPECIFIED, ("GetConfig success!"));
  if (CL_OK == rc)
  {
    std::cout << "Result:" << strResult << std::endl;
    logInfo("DBAL","TEST","Result: GetConfig is success!");
  } else
  {
    logInfo("DBAL","TEST","Result: GetConfig is failed\n");
  }
}
