/*
 * Copyright (C) 2002-2012 OpenClovis Solutions Inc.  All Rights Reserved.
 *
 * This file is available  under  a  commercial  license  from  the
 * copyright  holder or the GNU General Public License Version 2.0.
 * 
 * The source code for  this program is not published  or otherwise 
 * divested of  its trade secrets, irrespective  of  what  has been 
 * deposited with the U.S. Copyright office.
 * 
 * This program is distributed in the  hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied  warranty  of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * For more  information, see  the file  COPYING provided with this
 * material.
 *
 */

#ifndef MGTERROR_HXX_
#define MGTERROR_HXX_

#ifdef __cplusplus
extern "C"
{
}
#endif
namespace MgtServer
{

  class MgtError : public std::exception
  {
  public:

    typedef enum
    {
      SAFPLUS_ERROR = 1, SYSTEM_ERROR = 2, YUMA_ERROR = 3, SNMP_ERROR = 4
    } ErrorFamily;

    const char* errStr;
    const char* file;
    int line;
    unsigned int error;

    MgtError(const char* str): errStr(str)
    {
    }

    MgtError(ErrorFamily family, unsigned int returnCode, const char* str = NULL, const char* filep = __FILE__, int linep = __LINE__): errStr(str)
    {
      error = returnCode;
      file = filep;
      line = linep;
    }

    virtual const char* what() const throw()
    {
      return errStr;
    }
  };

  class MgtErrorStr : public MgtError
  {
  public:
    char err[256];
    MgtErrorStr(ErrorFamily family, unsigned int returnCode, const char* str = NULL, const char* filep = __FILE__, int linep = __LINE__): MgtError(family, returnCode, err, filep, linep)
    {
      strncpy(err, str, 256);
    }
  };

}
#endif /* CLMGT_HXX_ */
