#ifndef MGTSNMPHANDLER_HXX_
#define MGTSNMPHANDLER_HXX_

#include <string>
#include <map>
#include <clMgtMsgHandler.hxx>
#include <clMgtSnmpDefs.hxx>
#include <clMgtSnmpOM.hxx>

namespace MgtServer
{
  class MgtSnmpHandler
  {
    private:
      MgtSnmpHandler();
      ~MgtSnmpHandler();
      static MgtSnmpHandler* instance;

    public:
      static MgtSnmpHandler *getInstance();
      static void DestroyInstance();

      ClRcT snmpInitialize(int argc, ClCharT *argv[]);
      void mgtMsgBindHandle(SAFplus::Handle from, void *pInMsg);
      void mgtMsgNotifHandle(SAFplus::Handle from, void *pInMsg);

      static char getBaseTypeString(SmiBasetype basetype);
      static string toUpper(const string &);
      static string toCamelcase(const string &);
      static void getParentXpathNode(std::string &path, SmiNode *node, const string &moduleName, std::string &sep);

      void registerSMIModule(SmiModule *smiModule, const std::string &);
      void LoadMIBModule(const std::string &name);

      MgtMibModuleOM *findModuleOM(const std::string &module);
      MgtSnmpOM *findOM(const std::string &module, const ClUint32T *oid, ClUint32T len);
      void findListOM(const std::string &module, const ClUint32T *oid, const ClUint32T len, std::list<MgtSnmpOM*> &);
      void findListOM(SAFplus::Handle findHdl, std::list<MgtSnmpOM*> &elems);

      MgtSnmpNotificationInfo *findNotifOM(const std::string &module, const std::string &route);

#if 0
      void mgtSnmpDataGet(MgtSnmpOM *omEntry, std::string &output);
      ClRcT mgtSnmpDataSet(const MgtSnmpOM *omEntry, string &data);
#endif

      std::map<std::string, MgtMibModuleOM*> mModuleOMs;

      static ClRcT CheckAndLoadMibModule(std::vector<std::string> &nodes, const std::vector<std::string> &paths, std::map<std::string,bool> *mapLoadFailed);
  };

#endif /* MGTSNMPHANDLER_HXX_ */
}
