#include <ComponentsKey.hxx>

using namespace std;

namespace multikeyTest
{
  /* default constructor/destructor */
  ComponentsKey::ComponentsKey() 
  {
  }

  ComponentsKey::~ComponentsKey()
  {
  }

  ComponentsKey::ComponentsKey(std::string &nameValue, unsigned int &idValue) 
  {
    name = nameValue;
    id = idValue;
  }

  /* building an instance from string list */
  void ComponentsKey::build(std::map<std::string,std::string> &keyList)
  {
    std::map<std::string,std::string>::iterator iter;
    
    iter = keyList.find("name");
    if(iter != keyList.end())
    {
      std::stringstream nameStrStream;
      nameStrStream << iter->second;
      nameStrStream >> name;
    }

    iter = keyList.find("id");
    if(iter != keyList.end())
    {
      std::stringstream idStrStream;
      idStrStream << iter->second;
      idStrStream >> id;
    }
  }

  /* key xpath: [@key1="value1" and @key2="value2" and ...] */
  std::string ComponentsKey::toXpath() const
  {
    std::stringstream ss;
    ss << "[" << "@name=\"" <<name <<"\"" << " and " << "@id=\"" <<id <<"\"" << "]";
    return ss.str();
  }

  /* xml string: <interface key1="value1" key2="value2"></interface> */
  std::string ComponentsKey::toString() const
  {
    std::stringstream ss;
    ss<< "name=\"" << name << "\" "<<"id=\"" << id << "\"";
    return ss.str();
  }

  /* Serialize keys */
  std::string ComponentsKey::str() const
  {
    std::stringstream ss;
    ss<< name <<id;
    return ss.str();
  }

  std::ostream& operator<<(std::ostream& out, const ComponentsKey &value)
  {
    out<< value.name <<value.id;
    return out;
  }

}
/* namespace multikeyTest */
