#pragma once 
#ifndef __COMPONENTSKEY_HXX__
#define __COMPONENTSKEY_HXX__

#include <iostream>
#include <sstream>
#include <map>

namespace multikeyTest
{
  class ComponentsKey {

    public:
      std::string name;
      unsigned int id;

      /* default constructor/destructor */
      ComponentsKey();
      ~ComponentsKey();

      ComponentsKey(std::string &nameValue, unsigned int &idValue);

      /* building an instance from string list */
      void build(std::map<std::string,std::string> &keyList);

      /* key xpath: [@key1="value1" and @key2="value2" and ...] */
      std::string toXpath() const;

      /* xml string: <interface key1="value1" key2="value2"></interface> */
      std::string toString() const;

      /* Serialize keys */
      std::string str() const;

      friend std::ostream& operator<<(std::ostream& out, const ComponentsKey &value);

      /* compare hash key */
      inline bool operator<(const ComponentsKey &rhs) const
      {
        /* TODO: implement by user */
        return true;
      }

  };
}
/* namespace multikeyTest */
#endif /* COMPONENTSKEY_HXX_ */
